local SPELLLIB_MAJOR, SPELLLIB_MINOR = "SpellLib-1.0", 1
local SpellLib = LibStub:NewLibrary(SPELLLIB_MAJOR, SPELLLIB_MINOR)

SpellLib.errorText = "|cffff0000ERROR:|"
SpellLib.classSpells = {}
SpellLib.classNames = {"DEATHKNIGHT", "DEMONHUNTER", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", "ALL"}
SpellLib.specNames = {"BLOOD", "FROST", "UNHOLY", "HAVOC", "VENGEANCE", "BALANCE", "FERAL", "GUARDIAN", "RESTORATION", "MARKSMANSHIP", "BEASTMASTERY", "SURVIVAL", "FIRE", "ARCANE", "WINDWALKER", "MISTWEAVER", "BREWMASTER", "RETRIBUTION", "HOLY", "PROTECTION", "DISCIPLINE", "SHADOW","SUBTLETY", "ASSASSINATION", "OUTLAW", "ELEMENTAL", "ENHANCEMENT", "DESTRUCTION", "DEMONOLOGY", "AFFLICTION", "FURY", "ARMS", "BASIC", "COVENANT", "ALL"}
SpellLib.classSpecList = {
    ["DEATHKNIGHT"] = {"BLOOD", "FROST", "UNHOLY"},
    ["DEMONHUNTER"] = {"HAVOC", "VENGEANCE"},
    ["DRUID"] = {"BALANCE", "FERAL", "GUARDIAN", "RESTORATION"},
    ["HUNTER"] = {"BEASTMASTERY", "MARKSMANSHIP", "SURVIVAL"},
    ["MAGE"] = {"ARCANE", "FIRE", "FROST"},
    ["MONK"] = {"BREWMASTER", "MISTWEAVER", "WINDWALKER"},
    ["PALADIN"] = {"HOLY", "PROTECTION", "RETRIBUTION"},
    ["PRIEST"] = {"DISCIPLINE", "HOLY", "SHADOW"},
    ["ROGUE"] = {"ASSASSINATION", "OUTLAW", "SUBTLETY"},
    ["SHAMAN"] = {"ELEMENTAL", "ENHANCEMENT", "RESTORATION"},
    ["WARLOCK"] = {"AFFLICTION", "DEMONOLOG", "DESTRUCTION"},
    ["WARRIOR"] = {"ARMS", "FURY", "PROTECTION"}
}

function SpellLib:New()    
    self.classSpells = {
        DEATHKNIGHT = {
        	BASIC = {
        		{ name = "Anti-Magic Shell", id = 48707, passive = 0, rank = 1 },
        		{ name = "Anti-Magic Zone", id = 51052, passive = 0, rank = 1 },
        		{ name = "Chains of Ice", id = 45524, passive = 0, rank = 1 },
        		{ name = "Control Undead", id = 111673, passive = 0, rank = 1 },
        		{ name = "Dark Command", id = 56222, passive = 0, rank = 1 },
        		{ name = "Death's Advance", id = 48265, passive = 0, rank = 1 },
        		{ name = "Death's Advance", id = 343257, passive = 0, rank = 2 },
        		{ name = "Death Coil", id = 47541, passive = 0, rank = 1 },
        		{ name = "Death Gate", id = 50977, passive = 0, rank = 1 },
        		{ name = "Death Grip", id = 49576, passive = 0, rank = 1 },
        		{ name = "Death Strike", id = 49998, passive = 0, rank = 1 },
        		{ name = "Death and Decay", id = 43265, passive = 0, rank = 1 },
        		{ name = "Icebound Fortitude", id = 48792, passive = 0, rank = 1 },
        		{ name = "Lichborne", id = 49039, passive = 0, rank = 1 },
        		{ name = "Mind Freeze", id = 47528, passive = 0, rank = 1 },
        		{ name = "On a Pale Horse", id = 51986, passive = 0, rank = 1 },
        		{ name = "Path of Frost", id = 3714, passive = 0, rank = 1 },
        		{ name = "Raise Ally", id = 61999, passive = 0, rank = 1 },
        		{ name = "Raise Dead", id = 46585, passive = 0, rank = 1 },
        		{ name = "Runeforging", id = 53428, passive = 0, rank = 1 },
        		{ name = "Sacrificial Pact", id = 327574, passive = 0, rank = 1 },
        		{ name = "Veteran of the Third War", id = 48263, passive = 0, rank = 1 },
        	},
        	BLOOD = {
        		{ name = "Asphyxiate", id = 221562, passive = 0, rank = 1 },
        		{ name = "Blood Boil", id = 316634, passive = 0, rank = 2 },
        		{ name = "Blood Boil", id = 50842, passive = 0, rank = 1 },
        		{ name = "Crimson Scourge", id = 81136, passive = 0, rank = 1 },
        		{ name = "Dancing Rune Weapon", id = 49028, passive = 0, rank = 1 },
        		{ name = "Death's Caress", id = 195292, passive = 0, rank = 1 },
        		{ name = "Death and Decay", id = 316664, passive = 0, rank = 2 },
        		{ name = "Gorefiend's Grasp", id = 108199, passive = 0, rank = 1 },
        		{ name = "Heart Strike", id = 206930, passive = 0, rank = 1 },
        		{ name = "Heart Strike", id = 317090, passive = 0, rank = 3 },
        		{ name = "Heart Strike", id = 316575, passive = 0, rank = 2 },        		
        		{ name = "Marrowrend", id = 195182, passive = 0, rank = 1 },
                { name = "Marrowrend", id = 316746, passive = 0, rank = 2 },
        		{ name = "Mastery: Blood Shield", id = 77513, passive = 0, rank = 1 },
        		{ name = "Ossuary", id = 219786, passive = 0, rank = 1 },        		
        		{ name = "Rune Tap", id = 194679, passive = 0, rank = 1 },
                { name = "Rune Tap", id = 316616, passive = 0, rank = 2 },        		
        		{ name = "Vampiric Blood", id = 55233, passive = 0, rank = 1 },
                { name = "Vampiric Blood", id = 317133, passive = 0, rank = 2 },
        		{ name = "Veteran of the Third War", id = 316714, passive = 0, rank = 2 },
        	},
        	FROST = {
        		{ name = "Dark Succor", id = 178819, passive = 0, rank = 1 },
        		{ name = "Death Strike", id = 278223, passive = 0, rank = 2 },        		
        		{ name = "Empower Rune Weapon", id = 47568, passive = 0, rank = 1 },
                { name = "Empower Rune Weapon", id = 317230, passive = 0, rank = 2 },
        		{ name = "Frost Strike", id = 49143, passive = 0, rank = 1 },
        		{ name = "Frost Strike", id = 316803, passive = 0, rank = 24 },
        		{ name = "Frostwyrm's Fury", id = 279302, passive = 0, rank = 1 },
        		{ name = "Howling Blast", id = 49184, passive = 0, rank = 1 },
        		{ name = "Killing Machine", id = 51128, passive = 0, rank = 1 },
        		{ name = "Killing Machine", id = 317214, passive = 0, rank = 2 },
        		{ name = "Mastery: Frozen Heart", id = 77514, passive = 0, rank = 1 },
        		{ name = "Might of the Frozen Wastes", id = 81333, passive = 0, rank = 1 },
        		{ name = "Might of the Frozen Wastes", id = 343252, passive = 0, rank = 2 },
        		{ name = "Obliterate", id = 49020, passive = 0, rank = 1 },
        		{ name = "Obliterate", id = 317198, passive = 0, rank = 2 },        		
        		{ name = "Pillar of Frost", id = 51271, passive = 0, rank = 1 },
                { name = "Pillar of Frost", id = 316849, passive = 0, rank = 2 },
        		{ name = "Remorseless Winter", id = 196770, passive = 0, rank = 1 },
        		{ name = "Remorseless Winter", id = 316794, passive = 0, rank = 2 },
        		{ name = "Rime", id = 59057, passive = 0, rank = 1 },
        		{ name = "Rime", id = 316838, passive = 0, rank = 2 },
        		{ name = "Runic Empowerment", id = 81229, passive = 0, rank = 1 },
        	},
        	UNHOLY = {        		        		
        		{ name = "Apocalypse", id = 275699, passive = 0, rank = 1 },
                { name = "Apocalypse", id = 316961, passive = 0, rank = 2 },
                { name = "Apocalypse", id = 343755, passive = 0, rank = 3 },
        		{ name = "Army of the Dead", id = 42650, passive = 0, rank = 1 },
        		{ name = "Dark Succor", id = 178819, passive = 0, rank = 1 },        		
        		{ name = "Dark Transformation", id = 63560, passive = 0, rank = 1 },
                { name = "Dark Transformation", id = 325554, passive = 0, rank = 2 },
        		{ name = "Death Coil", id = 316941, passive = 0, rank = 2 },
        		{ name = "Death Strike", id = 278223, passive = 0, rank = 2 },
        		{ name = "Death and Decay", id = 316916, passive = 0, rank = 2 },
        		{ name = "Epidemic", id = 207317, passive = 0, rank = 1 },
        		{ name = "Festering Strike", id = 85948, passive = 0, rank = 1 },
        		{ name = "Festering Strike", id = 316867, passive = 0, rank = 2 },
        		{ name = "Mastery: Dreadblade", id = 77515, passive = 0, rank = 1 },
        		{ name = "Outbreak", id = 77575, passive = 0, rank = 1 },
        		{ name = "Raise Dead", id = 46584, passive = 0, rank = 2 },
        		{ name = "Runic Corruption", id = 51462, passive = 0, rank = 1 },        		
        		{ name = "Scourge Strike", id = 55090, passive = 0, rank = 1 },
                { name = "Scourge Strike", id = 317234, passive = 0, rank = 2 },
        		{ name = "Sudden Doom", id = 49530, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Shackle the Unworthy", id = 312940, passive = 0, rank = 1 },
                { name = "Abomination Limb", id = 340735, passive = 0, rank = 1 },
                { name = "Death's Due", id = 324128, passive = 0, rank = 1 },
        		{ name = "Swarming Mist", id = 337043, passive = 0, rank = 1 }
        	},
        },
        DEMONHUNTER = {
        	BASIC = {
        		{ name = "Chaos Brand", id = 255260, passive = 0, rank = 1 },
        		{ name = "Chaos Strike", id = 344862, passive = 0, rank = 1 },        		
        		{ name = "Consume Magic", id = 278326, passive = 0, rank = 1 },
                { name = "Consume Magic", id = 320313, passive = 0, rank = 2 },
        		{ name = "Demon's Bite", id = 344859, passive = 0, rank = 1 },
        		{ name = "Demonic Wards", id = 278386, passive = 0, rank = 1 },
        		{ name = "Disrupt", id = 183782, passive = 0, rank = 2 },
        		{ name = "Disrupt", id = 320361, passive = 0, rank = 3 },
        		{ name = "Double Jump", id = 196055, passive = 0, rank = 1 },
        		{ name = "Fel Rush", id = 344865, passive = 0, rank = 1 },
        		{ name = "Glide", id = 131347, passive = 0, rank = 1 },        		
        		{ name = "Immolation Aura", id = 258920, passive = 0, rank = 1 },
                { name = "Immolation Aura", id = 320364, passive = 0, rank = 2 },
        		{ name = "Imprison", id = 217832, passive = 0, rank = 1 },
        		{ name = "Shattered Souls", id = 178940, passive = 0, rank = 1 },
        		{ name = "Spectral Sight", id = 188501, passive = 0, rank = 1 },
        		{ name = "Spectral Sight", id = 320379, passive = 0, rank = 2 },        		
        		{ name = "Throw Glaive", id = 185123, passive = 0, rank = 1 },
                { name = "Throw Glaive", id = 320386, passive = 0, rank = 2 },
        		{ name = "Torment", id = 185245, passive = 0, rank = 1 },
        	},
        	HAVOC = {        		
        		{ name = "Blade Dance", id = 188499, passive = 0, rank = 1 },
                { name = "Blade Dance", id = 320402, passive = 0, rank = 2 },
        		{ name = "Blur", id = 198589, passive = 0, rank = 1 },
        		{ name = "Blur", id = 320407, passive = 0, rank = 2 },        		
        		{ name = "Chaos Nova", id = 179057, passive = 0, rank = 1 },
                { name = "Chaos Nova", id = 320412, passive = 0, rank = 2 },
        		{ name = "Chaos Strike", id = 162794, passive = 0, rank = 1 },        		
        		{ name = "Chaos Strike", id = 320413, passive = 0, rank = 2 },
                { name = "Chaos Strike", id = 343206, passive = 0, rank = 3 },
        		{ name = "Darkness", id = 320420, passive = 0, rank = 2 },
        		{ name = "Darkness", id = 196718, passive = 0, rank = 1 },
        		{ name = "Demon's Bite", id = 162243, passive = 0, rank = 1 },
        		{ name = "Demonic Wards", id = 320383, passive = 0, rank = 2 },        		
        		{ name = "Eye Beam", id = 198013, passive = 0, rank = 1 },
                { name = "Eye Beam", id = 320415, passive = 0, rank = 2 },
        		{ name = "Eye Beam", id = 343311, passive = 0, rank = 3 },
        		{ name = "Fel Rush", id = 195072, passive = 0, rank = 1 },
                { name = "Fel Rush", id = 320416, passive = 0, rank = 2 },
                { name = "Fel Rush", id = 343017, passive = 0, rank = 3 },
        		{ name = "Immolation Aura", id = 320377, passive = 0, rank = 3 },        		
        		{ name = "Mastery: Demonic Presence", id = 185164, passive = 0, rank = 1 },
                { name = "Mastery: Demonic Presence", id = 320654, passive = 0, rank = 2 },        		
        		{ name = "Metamorphosis", id = 320422, passive = 0, rank = 2 },
                { name = "Metamorphosis", id = 320421, passive = 0, rank = 3 },
        		{ name = "Metamorphosis", id = 320645, passive = 0, rank = 4 },
        		{ name = "Unrestrained Fury", id = 320770, passive = 0, rank = 1 },
        		{ name = "Unrestrained Fury", id = 343006, passive = 0, rank = 2 },
        		{ name = "Vengeful Retreat", id = 198793, passive = 0, rank = 1 },
                { name = "Vengeful Retreat", id = 320635, passive = 0, rank = 2 },
        	},
        	VENGEANCE = {
        		{ name = "Chaos Brand", id = 281242, passive = 0, rank = 1 },
        		{ name = "Demon Spikes", id = 203720, passive = 0, rank = 1 },
        		{ name = "Demon Spikes", id = 321028, passive = 0, rank = 2 },
        		{ name = "Demonic Wards", id = 203513, passive = 0, rank = 1 },
        		{ name = "Demonic Wards", id = 320382, passive = 0, rank = 3 },
        		{ name = "Demonic Wards", id = 320381, passive = 0, rank = 2 },
        		{ name = "Fel Devastation", id = 212084, passive = 0, rank = 1 },
        		{ name = "Fel Devastation", id = 320639, passive = 0, rank = 2 },
        		{ name = "Fiery Brand", id = 343010, passive = 0, rank = 3 },
        		{ name = "Fiery Brand", id = 320962, passive = 0, rank = 2 },
        		{ name = "Fiery Brand", id = 204021, passive = 0, rank = 1 },
        		{ name = "Immolation Aura", id = 320378, passive = 0, rank = 3 },
        		{ name = "Infernal Strike", id = 343016, passive = 0, rank = 3 },
        		{ name = "Infernal Strike", id = 320791, passive = 0, rank = 2 },
        		{ name = "Infernal Strike", id = 189110, passive = 0, rank = 1 },        		
        		{ name = "Mastery: Fel Blood", id = 203747, passive = 0, rank = 1 },
                { name = "Mastery: Fel Blood", id = 321299, passive = 0, rank = 2 },
        		{ name = "Metamorphosis", id = 321067, passive = 0, rank = 2 },
        		{ name = "Metamorphosis", id = 321068, passive = 0, rank = 3 },
        		{ name = "Revel in Pain", id = 343014, passive = 0, rank = 1 },
        		{ name = "Shattered Souls", id = 204254, passive = 0, rank = 1 },
        		{ name = "Shear", id = 203782, passive = 0, rank = 1 },
        		{ name = "Sigil of Flame", id = 204596, passive = 0, rank = 1 },
        		{ name = "Sigil of Flame", id = 320794, passive = 0, rank = 2 },
        		{ name = "Sigil of Misery", id = 207684, passive = 0, rank = 1 },
        		{ name = "Sigil of Misery", id = 320418, passive = 0, rank = 2 },        		
        		{ name = "Sigil of Silence", id = 202137, passive = 0, rank = 1 },
                { name = "Sigil of Silence", id = 320417, passive = 0, rank = 2 },        		
        		{ name = "Soul Cleave", id = 321021, passive = 0, rank = 2 },
                { name = "Soul Cleave", id = 343207, passive = 0, rank = 3 },
        		{ name = "Soul Cleave", id = 228477, passive = 0, rank = 1 },
        		{ name = "Thick Skin", id = 320380, passive = 0, rank = 1 },
        		{ name = "Throw Glaive", id = 320387, passive = 0, rank = 3 },
        		{ name = "Throw Glaive", id = 204157, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Elysian Decree", id = 306830, passive = 0, rank = 1 },
        		{ name = "Fodder to the Flame", id = 329554, passive = 0, rank = 1 },
        		{ name = "The Hunt", id = 323639, passive = 0, rank = 1 },
                { name = "Sinful Brand", id = 317009, passive = 0, rank = 1 }
        	},
        },
        DRUID = {
        	BASIC = {
        		{ name = "Aquatic Form", id = 276012, passive = 0, rank = 1 },
        		{ name = "Barkskin", id = 22812, passive = 0, rank = 1 },
        		{ name = "Bear Form", id = 5487, passive = 0, rank = 1 },
        		{ name = "Cat Form", id = 768, passive = 0, rank = 1 },
        		{ name = "Cyclone", id = 33786, passive = 0, rank = 1 },
        		{ name = "Dash", id = 1850, passive = 0, rank = 1 },
        		{ name = "Dreamwalk", id = 193753, passive = 0, rank = 1 },        		
        		{ name = "Entangling Roots", id = 339, passive = 0, rank = 1 },
                { name = "Entangling Roots", id = 343238, passive = 0, rank = 2 },
        		{ name = "Ferocious Bite", id = 22568, passive = 0, rank = 1 },
        		{ name = "Flight Form", id = 276029, passive = 0, rank = 1 },
        		{ name = "Growl", id = 6795, passive = 0, rank = 1 },
        		{ name = "Heart of the Wild", id = 319454, passive = 0, rank = 1 },
        		{ name = "Hibernate", id = 2637, passive = 0, rank = 1 },
        		{ name = "Ironfur", id = 192081, passive = 0, rank = 1 },
        		{ name = "Mangle", id = 33917, passive = 0, rank = 1 },
        		{ name = "Moonfire", id = 8921, passive = 0, rank = 1 },
        		{ name = "Prowl", id = 5215, passive = 0, rank = 1 },
        		{ name = "Rebirth", id = 20484, passive = 0, rank = 1 },        		
        		{ name = "Regrowth", id = 8936, passive = 0, rank = 1 },
                { name = "Regrowth", id = 231032, passive = 0, rank = 2 },
        		{ name = "Revive", id = 50769, passive = 0, rank = 1 },
        		{ name = "Shred", id = 5221, passive = 0, rank = 1 },
        		{ name = "Soothe", id = 2908, passive = 0, rank = 1 },
        		{ name = "Stampeding Roar", id = 106898, passive = 0, rank = 1 },
        		{ name = "Travel Form", id = 783, passive = 0, rank = 1 },
        		{ name = "Wrath", id = 5176, passive = 0, rank = 1 },
        	},
        	BALANCE = {
        		{ name = "Astral Influence", id = 197524, passive = 0, rank = 1 },
        		{ name = "Celestial Alignment", id = 194223, passive = 0, rank = 1 },        		
        		{ name = "Eclipse", id = 79577, passive = 0, rank = 1 },
                { name = "Eclipse", id = 328021, passive = 0, rank = 2 },
        		{ name = "Innervate", id = 29166, passive = 0, rank = 1 },
        		{ name = "Mastery: Total Eclipse", id = 326085, passive = 0, rank = 1 },
        		{ name = "Moonfire", id = 328023, passive = 0, rank = 3 },        		
        		{ name = "Moonkin Form", id = 24858, passive = 0, rank = 1 },
                { name = "Moonkin Form", id = 231042, passive = 0, rank = 2 },
        		{ name = "Remove Corruption", id = 2782, passive = 0, rank = 1 },
        		{ name = "Shooting Stars", id = 202342, passive = 0, rank = 1 },
        		{ name = "Solar Beam", id = 78675, passive = 0, rank = 1 },        		
        		{ name = "Starfall", id = 191034, passive = 0, rank = 1 },
                { name = "Starfall", id = 327541, passive = 0, rank = 2 },
        		{ name = "Starfire", id = 194153, passive = 0, rank = 1 },        		
        		{ name = "Starsurge", id = 78674, passive = 0, rank = 1 },
                { name = "Starsurge", id = 328022, passive = 0, rank = 2 },        		
        		{ name = "Sunfire", id = 93402, passive = 0, rank = 1 },
                { name = "Sunfire", id = 231050, passive = 0, rank = 2 },
        		{ name = "Typhoon", id = 132469, passive = 0, rank = 1 },
        		{ name = "Wrath", id = 190984, passive = 0, rank = 1 },
        	},
        	FERAL = {
        		{ name = "Berserk", id = 106951, passive = 0, rank = 1 },
        		{ name = "Berserk", id = 343223, passive = 0, rank = 2 },
        		{ name = "Feline Adept", id = 300349, passive = 0, rank = 1 },
        		{ name = "Feline Swiftness", id = 131768, passive = 0, rank = 1 },
        		{ name = "Feral Instinct", id = 16949, passive = 0, rank = 1 },
        		{ name = "Infected Wounds", id = 48484, passive = 0, rank = 1 },
        		{ name = "Maim", id = 22570, passive = 0, rank = 1 },
        		{ name = "Mastery: Razor Claws", id = 77493, passive = 0, rank = 1 },
        		{ name = "Omen of Clarity", id = 16864, passive = 0, rank = 1 },
        		{ name = "Predatory Swiftness", id = 16974, passive = 0, rank = 1 },
        		{ name = "Primal Fury", id = 159286, passive = 0, rank = 1 },
        		{ name = "Rake", id = 1822, passive = 0, rank = 1 },
        		{ name = "Rake", id = 231052, passive = 0, rank = 2 },
        		{ name = "Remove Corruption", id = 2782, passive = 0, rank = 1 },
        		{ name = "Rip", id = 1079, passive = 0, rank = 1 },
        		{ name = "Shred", id = 231057, passive = 0, rank = 2 },        		
        		{ name = "Shred", id = 231063, passive = 0, rank = 3 },
                { name = "Shred", id = 343232, passive = 0, rank = 4 },
        		{ name = "Skull Bash", id = 106839, passive = 0, rank = 1 },
        		{ name = "Survival Instincts", id = 61336, passive = 0, rank = 1 },
        		{ name = "Swipe", id = 213764, passive = 0, rank = 1 },
        		{ name = "Swipe", id = 231283, passive = 0, rank = 2 },
        		{ name = "Thrash", id = 106832, passive = 0, rank = 1 },
        		{ name = "Tiger's Fury", id = 5217, passive = 0, rank = 1 },
        		{ name = "Tiger's Fury", id = 231055, passive = 0, rank = 2 },
        	},
        	GUARDIAN = {
        		{ name = "Bear Form", id = 270100, passive = 0, rank = 2 },
        		{ name = "Berserk", id = 50334, passive = 0, rank = 1 },
        		{ name = "Berserk", id = 343240, passive = 0, rank = 2 },        		
        		{ name = "Frenzied Regeneration", id = 22842, passive = 0, rank = 1 },
        		{ name = "Frenzied Regeneration", id = 273048, passive = 0, rank = 2 },
                { name = "Frenzied Regeneration", id = 301768, passive = 0, rank = 3 },
        		{ name = "Gore", id = 210706, passive = 0, rank = 1 },
        		{ name = "Incapacitating Roar", id = 99, passive = 0, rank = 1 },
        		{ name = "Infected Wounds", id = 345208, passive = 0, rank = 1 },
        		{ name = "Ironfur", id = 231070, passive = 0, rank = 2 },
        		{ name = "Lightning Reflexes", id = 231065, passive = 0, rank = 1 },
        		{ name = "Mangle", id = 231064, passive = 0, rank = 2 },
        		{ name = "Mastery: Nature's Guardian", id = 155783, passive = 0, rank = 1 },
        		{ name = "Maul", id = 6807, passive = 0, rank = 1 },
        		{ name = "Remove Corruption", id = 2782, passive = 0, rank = 1 },
        		{ name = "Skull Bash", id = 106839, passive = 0, rank = 1 },
        		{ name = "Stampeding Roar", id = 288826, passive = 0, rank = 2 },
        		{ name = "Survival Instincts", id = 61336, passive = 0, rank = 1 },
        		{ name = "Survival Instincts", id = 328767, passive = 0, rank = 2 },
        		{ name = "Swipe", id = 213764, passive = 0, rank = 1 },
        		{ name = "Thick Hide", id = 16931, passive = 0, rank = 1 },
        		{ name = "Thrash", id = 106832, passive = 0, rank = 1 },
        		{ name = "Ursine Adept", id = 300346, passive = 0, rank = 1 },
        	},
        	RESTORATION = {
        		{ name = "Efflorescence", id = 145205, passive = 0, rank = 1 },        		
        		{ name = "Innervate", id = 29166, passive = 0, rank = 1 },
                { name = "Innervate", id = 326228, passive = 0, rank = 2 },        		
        		{ name = "Ironbark", id = 102342, passive = 0, rank = 1 },
                { name = "Ironbark", id = 197061, passive = 0, rank = 2 },
        		{ name = "Lifebloom", id = 33763, passive = 0, rank = 1 },
        		{ name = "Mastery: Harmony", id = 77495, passive = 0, rank = 1 },
        		{ name = "Nature's Cure", id = 88423, passive = 0, rank = 1 },
        		{ name = "Nature's Swiftness", id = 132158, passive = 0, rank = 1 },
        		{ name = "Omen of Clarity", id = 113043, passive = 0, rank = 1 },
        		{ name = "Rejuvenation", id = 774, passive = 0, rank = 1 },
        		{ name = "Rejuvenation", id = 231040, passive = 0, rank = 2 },
        		{ name = "Revitalize", id = 212040, passive = 0, rank = 1 },        		
        		{ name = "Sunfire", id = 93402, passive = 0, rank = 1 },
                { name = "Sunfire", id = 231050, passive = 0, rank = 2 },
        		{ name = "Swiftmend", id = 18562, passive = 0, rank = 1 },
        		{ name = "Tranquility", id = 740, passive = 0, rank = 1 },
        		{ name = "Ursol's Vortex", id = 102793, passive = 0, rank = 1 },
        		{ name = "Wild Growth", id = 48438, passive = 0, rank = 1 },
        		{ name = "Wild Growth", id = 328025, passive = 0, rank = 2 },
        		{ name = "Ysera's Gift", id = 145108, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Kindred Spirits", id = 326434, passive = 0, rank = 1 },
                { name = "Adaptive Swarm", id = 325727, passive = 0, rank = 1 },
        		{ name = "Convoke the Spirits", id = 323764, passive = 0, rank = 1 },
        		{ name = "Ravenous Frenzy", id = 323546, passive = 0, rank = 1 }
        	},
        },
        HUNTER = {
        	BASIC = {
        		{ name = "Arcane Shot", id = 185358, passive = 0, rank = 1 },
        		{ name = "Aspect of the Cheetah", id = 186257, passive = 0, rank = 1 },
        		{ name = "Aspect of the Cheetah", id = 343241, passive = 0, rank = 2 },
        		{ name = "Aspect of the Turtle", id = 186265, passive = 0, rank = 1 },
        		{ name = "Beast Lore", id = 1462, passive = 0, rank = 1 },
        		{ name = "Call Pet 2", id = 83242, passive = 0, rank = 1 },
        		{ name = "Call Pet 3", id = 83243, passive = 0, rank = 1 },
        		{ name = "Call Pet 4", id = 83244, passive = 0, rank = 1 },
        		{ name = "Call Pet 5", id = 83245, passive = 0, rank = 1 },
        		{ name = "Command Pet", id = 272651, passive = 0, rank = 1 },
        		{ name = "Disengage", id = 781, passive = 0, rank = 1 },
        		{ name = "Dismiss Pet", id = 2641, passive = 0, rank = 1 },
        		{ name = "Eagle Eye", id = 6197, passive = 0, rank = 1 },
        		{ name = "Exhilaration", id = 109304, passive = 0, rank = 1 },
        		{ name = "Eyes of the Beast", id = 321297, passive = 0, rank = 1 },
        		{ name = "Feed Pet", id = 6991, passive = 0, rank = 1 },
        		{ name = "Feign Death", id = 5384, passive = 0, rank = 1 },
        		{ name = "Flare", id = 1543, passive = 0, rank = 1 },
        		{ name = "Freezing Trap", id = 187650, passive = 0, rank = 1 },
        		{ name = "Hunter's Mark", id = 257284, passive = 0, rank = 1 },
        		{ name = "Improved Traps", id = 343247, passive = 0, rank = 2 },        		
        		{ name = "Kill Shot", id = 53351, passive = 0, rank = 1 },
                { name = "Kill Shot", id = 343248, passive = 0, rank = 2 },
        		{ name = "Mend Pet", id = 136, passive = 0, rank = 1 },
        		{ name = "Mend Pet", id = 343242, passive = 0, rank = 2 },
        		{ name = "Misdirection", id = 34477, passive = 0, rank = 1 },
        		{ name = "Scare Beast", id = 1513, passive = 0, rank = 1 },
        		{ name = "Steady Shot", id = 56641, passive = 0, rank = 1 },
        		{ name = "Tame Beast", id = 1515, passive = 0, rank = 1 },
        		{ name = "Tar Trap", id = 187698, passive = 0, rank = 1 },        		
        		{ name = "Tranquilizing Shot", id = 19801, passive = 0, rank = 1 },
                { name = "Tranquilizing Shot", id = 343244, passive = 0, rank = 2 },
        		{ name = "Wing Clip", id = 195645, passive = 0, rank = 1 },
        	},
        	BEASTMASTER = {
        		{ name = "Aspect of the Wild", id = 193530, passive = 0, rank = 1 },
        		{ name = "Barbed Shot", id = 217200, passive = 0, rank = 1 },
        		{ name = "Beast Cleave", id = 115939, passive = 0, rank = 1 },
        		{ name = "Bestial Wrath", id = 19574, passive = 0, rank = 1 },
        		{ name = "Bestial Wrath", id = 231548, passive = 0, rank = 2 },
        		{ name = "Cobra Shot", id = 193455, passive = 0, rank = 1 },
        		{ name = "Cobra Shot", id = 262838, passive = 0, rank = 2 },
        		{ name = "Concussive Shot", id = 5116, passive = 0, rank = 1 },
        		{ name = "Concussive Shot", id = 321023, passive = 0, rank = 1 },
        		{ name = "Counter Shot", id = 147362, passive = 0, rank = 1 },
        		{ name = "Exhilaration", id = 231546, passive = 0, rank = 2 },
        		{ name = "Exotic Beasts", id = 53270, passive = 0, rank = 1 },
        		{ name = "Intimidation", id = 19577, passive = 0, rank = 1 },
        		{ name = "Kill Command", id = 34026, passive = 0, rank = 1 },
        		{ name = "Kindred Spirits", id = 56315, passive = 0, rank = 1 },
        		{ name = "Mastery: Master of Beasts", id = 76657, passive = 0, rank = 1 },
        		{ name = "Multi-Shot", id = 2643, passive = 0, rank = 1 },
        		{ name = "Pack Tactics", id = 321014, passive = 0, rank = 1 },
        		{ name = "Wild Call", id = 185789, passive = 0, rank = 1 },
        	},
        	MARKSMANSHIP = {
        		{ name = "Aimed Shot", id = 19434, passive = 0, rank = 1 },
        		{ name = "Arcane Shot", id = 321293, passive = 0, rank = 2 },
        		{ name = "Binding Shot", id = 109248, passive = 0, rank = 1 },
        		{ name = "Bursting Shot", id = 186387, passive = 0, rank = 1 },
        		{ name = "Concussive Shot", id = 321023, passive = 0, rank = 1 },
        		{ name = "Concussive Shot", id = 5116, passive = 0, rank = 1 },
        		{ name = "Counter Shot", id = 147362, passive = 0, rank = 1 },
        		{ name = "Exhilaration", id = 231546, passive = 0, rank = 2 },
        		{ name = "Lone Wolf", id = 155228, passive = 0, rank = 1 },
        		{ name = "Mastery: Sniper Training", id = 193468, passive = 0, rank = 1 },
        		{ name = "Multi-Shot", id = 257620, passive = 0, rank = 1 },
        		{ name = "Precise Shots", id = 260240, passive = 0, rank = 1 },
        		{ name = "Rapid Fire", id = 257044, passive = 0, rank = 1 },
        		{ name = "Rapid Fire", id = 321281, passive = 0, rank = 2 },
        		{ name = "Steady Shot", id = 321018, passive = 0, rank = 2 },
        		{ name = "Trick Shots", id = 257621, passive = 0, rank = 1 },
        		{ name = "True Aim", id = 321287, passive = 0, rank = 1 },
        		{ name = "Trueshot", id = 288613, passive = 0, rank = 1 },
        	},
        	SURVIVAL = {
        		{ name = "Aspect of the Eagle", id = 186289, passive = 0, rank = 1 },        		
        		{ name = "Carve", id = 187708, passive = 0, rank = 1 },
                { name = "Carve", id = 294029, passive = 0, rank = 2 },
        		{ name = "Coordinated Assault", id = 266779, passive = 0, rank = 1 },
        		{ name = "Exhilaration", id = 231546, passive = 0, rank = 2 },
        		{ name = "Harpoon", id = 190925, passive = 0, rank = 1 },
        		{ name = "Harpoon", id = 231550, passive = 0, rank = 2 },
        		{ name = "Intimidation", id = 19577, passive = 0, rank = 1 },        		
        		{ name = "Kill Command", id = 259489, passive = 0, rank = 1 },
                { name = "Kill Command", id = 263186, passive = 0, rank = 2 },
        		{ name = "Kill Shot", id = 320976, passive = 0, rank = 1 },
        		{ name = "Mastery: Spirit Bond", id = 263135, passive = 0, rank = 1 },
        		{ name = "Muzzle", id = 187707, passive = 0, rank = 1 },
        		{ name = "Raptor Strike", id = 186270, passive = 0, rank = 1 },
        		{ name = "Serpent Sting", id = 259491, passive = 0, rank = 1 },
        		{ name = "Wildfire Bomb", id = 259495, passive = 0, rank = 1 },
        		{ name = "Wildfire Bombs", id = 321290, passive = 0, rank = 2 },
        		{ name = "Wing Clip", id = 321026, passive = 0, rank = 2 },
        	},
        	COVENANT = {
        		{ name = "Resonating Arrow", id = 308491, passive = 0, rank = 1 },
                { name = "Death Chakram", id = 325028, passive = 0, rank = 1 },
        		{ name = "Wild Spirits", id = 328231, passive = 0, rank = 1 },
                { name = "Flayed Shot", id = 324149, passive = 0, rank = 1 }
        	},
        },
        MAGE = {
        	BASIC = {
        		{ name = "Arcane Explosion", id = 1449, passive = 0, rank = 1 },
        		{ name = "Arcane Intellect", id = 1459, passive = 0, rank = 1 },
        		{ name = "Blink", id = 1953, passive = 0, rank = 1 },
        		{ name = "Conjure Refreshment", id = 190336, passive = 0, rank = 1 },
        		{ name = "Counterspell", id = 2139, passive = 0, rank = 1 },
        		{ name = "Fire Blast", id = 319836, passive = 0, rank = 1 },
        		{ name = "Frost Nova", id = 122, passive = 0, rank = 1 },
        		{ name = "Frostbolt", id = 116, passive = 0, rank = 1 },
        		{ name = "Ice Block", id = 45438, passive = 0, rank = 1 },
        		{ name = "Invisibility", id = 66, passive = 0, rank = 1 },
        		{ name = "Mirror Image", id = 55342, passive = 0, rank = 1 },
        		{ name = "Polymorph", id = 118, passive = 0, rank = 1 },
        		{ name = "Portal", id = 343140, passive = 0, rank = 1 },
        		{ name = "Remove Curse", id = 475, passive = 0, rank = 1 },
        		{ name = "Slow Fall", id = 130, passive = 0, rank = 1 },
        		{ name = "Spellsteal", id = 30449, passive = 0, rank = 1 },
        		{ name = "Teleport", id = 343127, passive = 0, rank = 1 },
        		{ name = "Time Warp", id = 80353, passive = 0, rank = 1 },
        	},
        	ARCANE = {
        		{ name = "Alter Time", id = 342245, passive = 0, rank = 1 },
        		{ name = "Arcane Barrage", id = 44425, passive = 0, rank = 1 },        		
        		{ name = "Arcane Barrage", id = 231564, passive = 0, rank = 2 },
                { name = "Arcane Barrage", id = 321526, passive = 0, rank = 3 },
        		{ name = "Arcane Blast", id = 30451, passive = 0, rank = 1 },
        		{ name = "Arcane Explosion", id = 321752, passive = 0, rank = 2 },
        		{ name = "Arcane Missiles", id = 5143, passive = 0, rank = 1 },
        		{ name = "Arcane Power", id = 12042, passive = 0, rank = 1 },
        		{ name = "Arcane Power", id = 343208, passive = 0, rank = 2 },
        		{ name = "Arcane Power", id = 321739, passive = 0, rank = 3 },
        		{ name = "Clearcasting", id = 79684, passive = 0, rank = 1 },
                { name = "Clearcasting", id = 321758, passive = 0, rank = 2 },
        		{ name = "Clearcasting", id = 321420, passive = 0, rank = 3 },        		
        		{ name = "Conjure Mana Gem", id = 759, passive = 0, rank = 1 },
        		{ name = "Evocation", id = 12051, passive = 0, rank = 1 },
        		{ name = "Evocation", id = 231565, passive = 0, rank = 2 },
        		{ name = "Greater Invisibility", id = 110959, passive = 0, rank = 1 },
        		{ name = "Mastery: Savant", id = 190740, passive = 0, rank = 1 },
        		{ name = "Presence of Mind", id = 321742, passive = 0, rank = 2 },
        		{ name = "Presence of Mind", id = 205025, passive = 0, rank = 1 },
        		{ name = "Prismatic Barrier", id = 235450, passive = 0, rank = 1 },
        		{ name = "Prismatic Barrier", id = 321745, passive = 0, rank = 2 },
        		{ name = "Slow", id = 321747, passive = 0, rank = 2 },
        		{ name = "Slow", id = 31589, passive = 0, rank = 1 },        		
        		{ name = "Touch of the Magi", id = 321507, passive = 0, rank = 1 },
                { name = "Touch of the Magi", id = 343215, passive = 0, rank = 2 },
        	},
        	FIRE = {
        		{ name = "Alter Time", id = 108978, passive = 0, rank = 1 },
        		{ name = "Blazing Barrier", id = 235313, passive = 0, rank = 1 },
        		{ name = "Blazing Barrier", id = 321708, passive = 0, rank = 2 },
        		{ name = "Cauterize", id = 86949, passive = 0, rank = 1 },
        		{ name = "Combustion", id = 321710, passive = 0, rank = 2 },
        		{ name = "Combustion", id = 190319, passive = 0, rank = 1 },
        		{ name = "Critical Mass", id = 231630, passive = 0, rank = 2 },
        		{ name = "Critical Mass", id = 117216, passive = 0, rank = 1 },
        		{ name = "Dragon's Breath", id = 321707, passive = 0, rank = 2 },
        		{ name = "Dragon's Breath", id = 31661, passive = 0, rank = 1 },        		        		
        		{ name = "Fire Blast", id = 231568, passive = 0, rank = 2 },
                { name = "Fire Blast", id = 108853, passive = 0, rank = 3 },
                { name = "Fire Blast", id = 231567, passive = 0, rank = 4 },
        		{ name = "Fireball", id = 133, passive = 0, rank = 1 },        		
        		{ name = "Fireball", id = 157642, passive = 0, rank = 2 },
                { name = "Fireball", id = 343194, passive = 0, rank = 3 },        		
        		{ name = "Flamestrike", id = 2120, passive = 0, rank = 1 },
        		{ name = "Flamestrike", id = 343230, passive = 0, rank = 2 },
                { name = "Flamestrike", id = 321709, passive = 0, rank = 3 },
        		{ name = "Hot Streak", id = 195283, passive = 0, rank = 1 },
        		{ name = "Mastery: Ignite", id = 12846, passive = 0, rank = 1 },        		
        		{ name = "Phoenix Flames", id = 257541, passive = 0, rank = 1 },
                { name = "Phoenix Flames", id = 343222, passive = 0, rank = 2 },
        		{ name = "Pyroblast", id = 11366, passive = 0, rank = 1 },
        		{ name = "Pyroblast", id = 321711, passive = 0, rank = 2 },
        		{ name = "Scorch", id = 2948, passive = 0, rank = 1 },
        	},
        	FROST = {
        		{ name = "Alter Time", id = 108978, passive = 0, rank = 1 },        		
        		{ name = "Blizzard", id = 190356, passive = 0, rank = 1 },
                { name = "Blizzard", id = 236662, passive = 0, rank = 2 },
        		{ name = "Blizzard", id = 321696, passive = 0, rank = 3 },        		
        		{ name = "Brain Freeze", id = 190447, passive = 0, rank = 1 },
                { name = "Brain Freeze", id = 231584, passive = 0, rank = 2 },
        		{ name = "Cold Snap", id = 235219, passive = 0, rank = 1 },
        		{ name = "Cold Snap", id = 321699, passive = 0, rank = 2 },
        		{ name = "Cone of Cold", id = 120, passive = 0, rank = 1 },
        		{ name = "Cone of Cold", id = 343180, passive = 0, rank = 2 },
        		{ name = "Fingers of Frost", id = 112965, passive = 0, rank = 1 },
        		{ name = "Flurry", id = 44614, passive = 0, rank = 1 },
        		{ name = "Freeze", id = 231596, passive = 0, rank = 1 },
        		{ name = "Frost Nova", id = 343183, passive = 0, rank = 2 },
        		{ name = "Frostbolt", id = 343177, passive = 0, rank = 2 },
        		{ name = "Frozen Orb", id = 84714, passive = 0, rank = 1 },
        		{ name = "Ice Barrier", id = 11426, passive = 0, rank = 1 },
        		{ name = "Ice Lance", id = 30455, passive = 0, rank = 1 },
        		{ name = "Ice Lance", id = 343175, passive = 0, rank = 2 },
        		{ name = "Icy Veins", id = 12472, passive = 0, rank = 1 },
        		{ name = "Icy Veins", id = 321702, passive = 0, rank = 2 },
        		{ name = "Mastery: Icicles", id = 76613, passive = 0, rank = 1 },
        		{ name = "Mastery: Icicles", id = 321684, passive = 0, rank = 2 },        		
        		{ name = "Shatter", id = 12982, passive = 0, rank = 1 },
                { name = "Shatter", id = 231582, passive = 0, rank = 2 },
        		{ name = "Summon Water Elemental", id = 31687, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Radiant Spark", id = 307443, passive = 0, rank = 1 },
                { name = "Deathborne", id = 324220, passive = 0, rank = 1 },
        		{ name = "Shifting Power", id = 314791, passive = 0, rank = 1 },
                { name = "Mirrors of Torment", id = 314793, passive = 0, rank = 1 }
        	},
        },
        MONK = {
        	BASIC = {
        		{ name = "Blackout Kick", id = 100784, passive = 0, rank = 1 },
        		{ name = "Crackling Jade Lightning", id = 117952, passive = 0, rank = 1 },
        		{ name = "Detox", id = 218164, passive = 0, rank = 1 },
        		{ name = "Expel Harm", id = 322101, passive = 0, rank = 1 },
        		{ name = "Fortifying Brew", id = 115203, passive = 0, rank = 1 },
        		{ name = "Leg Sweep", id = 119381, passive = 0, rank = 1 },
        		{ name = "Mystic Touch", id = 8647, passive = 0, rank = 1 },
        		{ name = "Paralysis", id = 115078, passive = 0, rank = 1 },
        		{ name = "Paralysis", id = 344359, passive = 0, rank = 2 },        		
        		{ name = "Provoke", id = 115546, passive = 0, rank = 1 },
                { name = "Provoke", id = 328670, passive = 0, rank = 2 },
        		{ name = "Resuscitate", id = 115178, passive = 0, rank = 1 },        		
        		{ name = "Roll", id = 109132, passive = 0, rank = 1 },
                { name = "Roll", id = 328669, passive = 0, rank = 2 },
        		{ name = "Spinning Crane Kick", id = 101546, passive = 0, rank = 1 },
        		{ name = "Tiger Palm", id = 100780, passive = 0, rank = 1 },        		
        		{ name = "Touch of Death", id = 322109, passive = 0, rank = 1 },
                { name = "Touch of Death", id = 322113, passive = 0, rank = 2 },
        		{ name = "Transcendence", id = 101643, passive = 0, rank = 1 },
        		{ name = "Transcendence: Transfer", id = 119996, passive = 0, rank = 1 },
        		{ name = "Vivify", id = 116670, passive = 0, rank = 1 },
        		{ name = "Zen Pilgrimage", id = 126892, passive = 0, rank = 1 },
        	},
        	BREWMASTER = {
        		{ name = "Blackout Kick", id = 205523, passive = 0, rank = 1 },
        		{ name = "Breath of Fire", id = 115181, passive = 0, rank = 1 },
        		{ name = "Brewmaster's Balance", id = 245013, passive = 0, rank = 1 },        		
        		{ name = "Celestial Brew", id = 322507, passive = 0, rank = 1 },
                { name = "Celestial Brew", id = 322510, passive = 0, rank = 2 },
        		{ name = "Celestial Fortune", id = 216519, passive = 0, rank = 1 },
        		{ name = "Clash", id = 324312, passive = 0, rank = 1 },
        		{ name = "Expel Harm", id = 322102, passive = 0, rank = 2 },
        		{ name = "Fortifying Brew", id = 322960, passive = 0, rank = 2 },
        		{ name = "Gift of the Ox", id = 124502, passive = 0, rank = 1 },        		
        		{ name = "Invoke Niuzao, the Black Ox", id = 132578, passive = 0, rank = 1 },
                { name = "Invoke Niuzao, the Black Ox", id = 322740, passive = 0, rank = 2 },
        		{ name = "Keg Smash", id = 121253, passive = 0, rank = 1 },
        		{ name = "Mastery: Elusive Brawler", id = 117906, passive = 0, rank = 1 },        		
        		{ name = "Purifying Brew", id = 119582, passive = 0, rank = 1 },
                { name = "Purifying Brew", id = 343743, passive = 0, rank = 2 },
        		{ name = "Shuffle", id = 322120, passive = 0, rank = 1 },
        		{ name = "Spear Hand Strike", id = 116705, passive = 0, rank = 1 },
        		{ name = "Spinning Crane Kick", id = 322729, passive = 0, rank = 1 },
        		{ name = "Spinning Crane Kick", id = 322700, passive = 0, rank = 2 },
        		{ name = "Stagger", id = 322522, passive = 0, rank = 2 },
        		{ name = "Stagger", id = 115069, passive = 0, rank = 1 },
        		{ name = "Touch of Death", id = 325095, passive = 0, rank = 3 },
        		{ name = "Vivify", id = 231602, passive = 0, rank = 2 },        		
        		{ name = "Zen Meditation", id = 115176, passive = 0, rank = 1 },
                { name = "Zen Meditation", id = 328682, passive = 0, rank = 2 },
        	},
        	MISTWEAVER = {
        		{ name = "Detox", id = 115450, passive = 0, rank = 1 },
        		{ name = "Enveloping Breath", id = 343655, passive = 0, rank = 1 },        		
        		{ name = "Enveloping Mist", id = 124682, passive = 0, rank = 1 },
                { name = "Enveloping Mist", id = 231605, passive = 0, rank = 2 },
        		{ name = "Essence Font", id = 231633, passive = 0, rank = 2 },
        		{ name = "Essence Font", id = 191837, passive = 0, rank = 1 },        		
        		{ name = "Expel Harm", id = 322104, passive = 0, rank = 2 },
                { name = "Expel Harm", id = 325214, passive = 0, rank = 3 },
        		{ name = "Fortifying Brew", id = 325208, passive = 0, rank = 2 },
        		{ name = "Fortifying Brew", id = 243435, passive = 0, rank = 1 },
        		{ name = "Invoke Yu'lon, the Jade Serpent", id = 322118, passive = 0, rank = 1 },        		
        		{ name = "Life Cocoon", id = 116849, passive = 0, rank = 1 },
                { name = "Life Coccoon", id = 343744, passive = 0, rank = 2 },
        		{ name = "Mastery: Gust of Mists", id = 117907, passive = 0, rank = 1 },
        		{ name = "Reawaken", id = 212051, passive = 0, rank = 1 },
        		{ name = "Renewing Mist", id = 115151, passive = 0, rank = 1 },
        		{ name = "Renewing Mist", id = 281231, passive = 0, rank = 2 },
        		{ name = "Revival", id = 115310, passive = 0, rank = 1 },        		
        		{ name = "Rising Sun Kick", id = 107428, passive = 0, rank = 1 },
                { name = "Rising Sun Kick", id = 262840, passive = 0, rank = 2 },
        		{ name = "Soothing Mist", id = 115175, passive = 0, rank = 1 },
        		{ name = "Teachings of the Monastery", id = 116645, passive = 0, rank = 1 },
        		{ name = "Thunder Focus Tea", id = 116680, passive = 0, rank = 1 },
        		{ name = "Thunder Focus Tea", id = 231876, passive = 0, rank = 2 },
        		{ name = "Touch of Death", id = 344360, passive = 0, rank = 3 },
        		{ name = "Vivify", id = 274586, passive = 0, rank = 2 },
        	},
        	WINDWALKER = {        		
        		{ name = "Afterlife", id = 116092, passive = 0, rank = 1 },
                { name = "Afterlife", id = 322719, passive = 0, rank = 2 },
        		{ name = "Blackout Kick", id = 261917, passive = 0, rank = 3 },
        		{ name = "Blackout Kick", id = 261916, passive = 0, rank = 2 },
        		{ name = "Disable", id = 116095, passive = 0, rank = 1 },
        		{ name = "Disable", id = 343731, passive = 0, rank = 2 },
        		{ name = "Expel Harm", id = 322106, passive = 0, rank = 2 },
        		{ name = "Fists of Fury", id = 113656, passive = 0, rank = 1 },
        		{ name = "Flying Serpent Kick", id = 101545, passive = 0, rank = 1 },
        		{ name = "Flying Serpent Kick", id = 344487, passive = 0, rank = 2 },
        		{ name = "Fortifying Brew", id = 243435, passive = 0, rank = 1 },
        		{ name = "Fortifying Brew", id = 325208, passive = 0, rank = 2 },        		
        		{ name = "Invoke Xuen, the White Tiger", id = 123904, passive = 0, rank = 1 },
                { name = "Invoke Xuen, the White Tiger", id = 323999, passive = 0, rank = 2 },
        		{ name = "Mastery: Combo Strikes", id = 115636, passive = 0, rank = 1 },
        		{ name = "Rising Sun Kick", id = 107428, passive = 0, rank = 1 },
        		{ name = "Rising Sun Kick", id = 262840, passive = 0, rank = 2 },
        		{ name = "Spear Hand Strike", id = 116705, passive = 0, rank = 1 },
        		{ name = "Spinning Crane Kick", id = 343730, passive = 0, rank = 2 },
        		{ name = "Storm, Earth, and Fire", id = 137639, passive = 0, rank = 1 },
        		{ name = "Storm, Earth, and Fire", id = 231627, passive = 0, rank = 2 },
        		{ name = "Touch of Death", id = 325215, passive = 0, rank = 3 },
        		{ name = "Touch of Karma", id = 122470, passive = 0, rank = 1 },
        		{ name = "Vivify", id = 231602, passive = 0, rank = 2 },
        		{ name = "Windwalking", id = 157411, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Weapons of Order", id = 310454, passive = 0, rank = 1 },
        		{ name = "Bonedust Brew", id = 325216, passive = 0, rank = 1 },
                { name = "Faeline Stomp", id = 327104, passive = 0, rank = 1 },
                { name = "Fallen Order", id = 326860, passive = 0, rank = 1 }
        	},
        },
        PALADIN = {
        	BASIC = {
        		{ name = "Avenging Wrath", id = 31884, passive = 0, rank = 1 },
        		{ name = "Avenging Wrath", id = 317872, passive = 0, rank = 2 },
        		{ name = "Blessing of Freedom", id = 1044, passive = 0, rank = 1 },
        		{ name = "Blessing of Protection", id = 1022, passive = 0, rank = 1 },
        		{ name = "Blessing of Sacrifice", id = 6940, passive = 0, rank = 1 },
        		{ name = "Blessing of Sacrifice", id = 200327, passive = 0, rank = 2 },
        		{ name = "Concentration Aura", id = 317920, passive = 0, rank = 1 },
        		{ name = "Consecration", id = 26573, passive = 0, rank = 1 },
        		{ name = "Crusader Aura", id = 32223, passive = 0, rank = 1 },
        		{ name = "Crusader Strike", id = 35395, passive = 0, rank = 1 },
        		{ name = "Devotion Aura", id = 465, passive = 0, rank = 1 },
        		{ name = "Divine Shield", id = 642, passive = 0, rank = 1 },
        		{ name = "Divine Steed", id = 190784, passive = 0, rank = 1 },
        		{ name = "Divine Steed", id = 317911, passive = 0, rank = 2 },
        		{ name = "Flash of Light", id = 19750, passive = 0, rank = 1 },
        		{ name = "Hammer of Justice", id = 853, passive = 0, rank = 1 },
        		{ name = "Hammer of Wrath", id = 24275, passive = 0, rank = 1 },
        		{ name = "Hammer of Wrath", id = 326730, passive = 0, rank = 2 },
        		{ name = "Hand of Reckoning", id = 62124, passive = 0, rank = 1 },
        		{ name = "Judgment", id = 20271, passive = 0, rank = 1 },
        		{ name = "Lay on Hands", id = 633, passive = 0, rank = 1 },
        		{ name = "Redemption", id = 7328, passive = 0, rank = 1 },        		
        		{ name = "Retribution Aura", id = 183435, passive = 0, rank = 1 },
                { name = "Retribution Aura", id = 317906, passive = 0, rank = 2 },
        		{ name = "Sense Undead", id = 5502, passive = 0, rank = 1 },
        		{ name = "Shield of the Righteous", id = 53600, passive = 0, rank = 1 },
        		{ name = "Turn Evil", id = 10326, passive = 0, rank = 1 },
        		{ name = "Word of Glory", id = 85673, passive = 0, rank = 1 },
        	},
        	HOLY = {
        		{ name = "Absolution", id = 212056, passive = 0, rank = 1 },
        		{ name = "Aura Mastery", id = 31821, passive = 0, rank = 1 },
        		{ name = "Avenging Wrath", id = 327979, passive = 0, rank = 3 },
        		{ name = "Beacon of Light", id = 53563, passive = 0, rank = 1 },
        		{ name = "Beacon of Light", id = 231642, passive = 0, rank = 2 },
        		{ name = "Cleanse", id = 4987, passive = 0, rank = 1 },
        		{ name = "Crusader Strike", id = 231667, passive = 0, rank = 3 },
        		{ name = "Divine Protection", id = 498, passive = 0, rank = 1 },
        		{ name = "Holy Light", id = 82326, passive = 0, rank = 1 },
        		{ name = "Holy Shock", id = 272906, passive = 0, rank = 2 },
        		{ name = "Holy Shock", id = 20473, passive = 0, rank = 1 },
        		{ name = "Infusion of Light", id = 53576, passive = 0, rank = 1 },
        		{ name = "Judgment", id = 275773, passive = 0, rank = 1 },
        		{ name = "Judgment", id = 231644, passive = 0, rank = 3 },
        		{ name = "Light of Dawn", id = 85222, passive = 0, rank = 1 },
        		{ name = "Light of the Martyr", id = 183998, passive = 0, rank = 1 },
        		{ name = "Mastery: Lightbringer", id = 183997, passive = 0, rank = 1 },
        	},
        	PROTECTION = {
        		{ name = "Ardent Defender", id = 31850, passive = 0, rank = 1 },        		
        		{ name = "Avenger's Shield", id = 31935, passive = 0, rank = 1 },
                { name = "Avenger's Shield", id = 231665, passive = 0, rank = 2 },
        		{ name = "Cleanse Toxins", id = 213644, passive = 0, rank = 1 },
        		{ name = "Consecration", id = 344172, passive = 0, rank = 2 },
        		{ name = "Consecration", id = 327980, passive = 0, rank = 3 },
        		{ name = "Crusader Strike", id = 342348, passive = 0, rank = 2 },
        		{ name = "Grand Crusader", id = 85043, passive = 0, rank = 1 },
        		{ name = "Guardian of Ancient Kings", id = 86659, passive = 0, rank = 1 },
        		{ name = "Hammer of the Righteous", id = 53595, passive = 0, rank = 1 },
        		{ name = "Hammer of the Righteous", id = 317854, passive = 0, rank = 2 },
        		{ name = "Judgment", id = 231663, passive = 0, rank = 4 },
        		{ name = "Judgment", id = 275779, passive = 0, rank = 1 },
        		{ name = "Judgment", id = 315867, passive = 0, rank = 3 },
        		{ name = "Mastery: Divine Bulwark", id = 76671, passive = 0, rank = 1 },
        		{ name = "Mastery: Divine Bulwark", id = 317907, passive = 0, rank = 2 },
        		{ name = "Rebuke", id = 96231, passive = 0, rank = 1 },
        		{ name = "Riposte", id = 161800, passive = 0, rank = 1 },
        		{ name = "Shining Light", id = 321136, passive = 0, rank = 1 },
        		{ name = "Word of Glory", id = 315921, passive = 0, rank = 2 },
        	},
        	RETRIBUTION = {        		
        		{ name = "Art of War", id = 267344, passive = 0, rank = 1 },
                { name = "Art of War", id = 317912, passive = 0, rank = 2 },        		
        		{ name = "Blade of Justice", id = 184575, passive = 0, rank = 1 },
                { name = "Blade of Justice", id = 327981, passive = 0, rank = 2 },
        		{ name = "Cleanse Toxins", id = 213644, passive = 0, rank = 1 },
                { name = "Crusader Strike", id = 35395, passive = 0, rank = 1 },
                { name = "Crusader Strike", id = 342348, passive = 0, rank = 2 },
        		{ name = "Crusader Strike", id = 231667, passive = 0, rank = 3 },
        		{ name = "Divine Storm", id = 53385, passive = 0, rank = 1 },
        		{ name = "Hand of Hindrance", id = 183218, passive = 0, rank = 1 },
        		{ name = "Judgment", id = 231663, passive = 0, rank = 4 },
        		{ name = "Judgment", id = 315867, passive = 0, rank = 3 },
        		{ name = "Mastery: Hand of Light", id = 267316, passive = 0, rank = 1 },
        		{ name = "Rebuke", id = 96231, passive = 0, rank = 1 },
        		{ name = "Shield of Vengeance", id = 184662, passive = 0, rank = 1 },
        		{ name = "Templar's Verdict", id = 85256, passive = 0, rank = 1 },
        		{ name = "Wake of Ashes", id = 255937, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Divine Toll", id = 304971, passive = 0, rank = 1 },
                { name = "Vanquisher's Hammer", id = 328204, passive = 0, rank = 1 },
        		{ name = "Blessing of the Seasons", id = 328278, passive = 0, rank = 1 },
                { name = "Ashen Hallow", id = 316958, passive = 0, rank = 1 },
        	},
        },
        PRIEST = {
        	BASIC = {
        		{ name = "Desperate Prayer", id = 19236, passive = 0, rank = 1 },
        		{ name = "Dispel Magic", id = 528, passive = 0, rank = 1 },
        		{ name = "Fade", id = 586, passive = 0, rank = 1 },
        		{ name = "Focused Will", id = 45243, passive = 0, rank = 1 },
        		{ name = "Leap of Faith", id = 73325, passive = 0, rank = 1 },
        		{ name = "Levitate", id = 1706, passive = 0, rank = 1 },
        		{ name = "Mass Dispel", id = 32375, passive = 0, rank = 1 },
        		{ name = "Mind Blast", id = 8092, passive = 0, rank = 1 },
        		{ name = "Mind Control", id = 605, passive = 0, rank = 1 },
        		{ name = "Mind Soothe", id = 453, passive = 0, rank = 1 },
        		{ name = "Mind Vision", id = 2096, passive = 0, rank = 1 },
        		{ name = "Pain Suppression", id = 33206, passive = 0, rank = 1 },
        		{ name = "Power Infusion", id = 10060, passive = 0, rank = 1 },
        		{ name = "Power Word: Fortitude", id = 21562, passive = 0, rank = 1 },
        		{ name = "Power Word: Shield", id = 17, passive = 0, rank = 1 },
        		{ name = "Psychic Scream", id = 8122, passive = 0, rank = 1 },
        		{ name = "Resurrection", id = 2006, passive = 0, rank = 1 },
        		{ name = "Shackle Undead", id = 9484, passive = 0, rank = 1 },
        		{ name = "Shadow Word: Death", id = 32379, passive = 0, rank = 1 },
        		{ name = "Smite", id = 585, passive = 0, rank = 1 },
        	},
        	DISCIPLINE = {
        		{ name = "Atonement", id = 81749, passive = 0, rank = 1 },
        		{ name = "Focused Will", id = 285485, passive = 0, rank = 2 },
        		{ name = "Holy Nova", id = 132157, passive = 0, rank = 1 },
        		{ name = "Holy Nova", id = 322112, passive = 0, rank = 2 },
                { name = "Mass Resurrection", id = 212036, passive = 0, rank = 1 },
        		{ name = "Mastery: Grace", id = 271534, passive = 0, rank = 1 },
        		{ name = "Mind Blast", id = 231682, passive = 0, rank = 2 },
        		{ name = "Mind Sear", id = 48045, passive = 0, rank = 1 },
        		{ name = "Pain Suppression", id = 33206, passive = 0, rank = 1 },
        		{ name = "Penance", id = 47540, passive = 0, rank = 1 },
        		{ name = "Power Word: Barrier", id = 62618, passive = 0, rank = 1 },        		
        		{ name = "Power Word: Radiance", id = 194509, passive = 0, rank = 1 },
                { name = "Power Word: Radiance", id = 322115, passive = 0, rank = 2 },
        		{ name = "Power of the Dark Side", id = 198068, passive = 0, rank = 1 },
        		{ name = "Purify", id = 527, passive = 0, rank = 1 },
        		{ name = "Rapture", id = 47536, passive = 0, rank = 1 },
        		{ name = "Shadow Mend", id = 186263, passive = 0, rank = 1 },        		
        		{ name = "Shadowfiend", id = 34433, passive = 0, rank = 1 },
                { name = "Shadowfiend", id = 343726, passive = 0, rank = 2 },
        		{ name = "Smite", id = 585, passive = 0, rank = 1 },
        		{ name = "Smite", id = 262861, passive = 0, rank = 2 },
        	},
        	HOLY = {
        		{ name = "Divine Hymn", id = 64843, passive = 0, rank = 1 },
        		{ name = "Flash Heal", id = 2061, passive = 0, rank = 1 },
        		{ name = "Focused Will", id = 285485, passive = 0, rank = 2 },
        		{ name = "Guardian Spirit", id = 47788, passive = 0, rank = 1 },
        		{ name = "Heal", id = 2060, passive = 0, rank = 1 },
        		{ name = "Holy Fire", id = 14914, passive = 0, rank = 1 },
        		{ name = "Holy Nova", id = 132157, passive = 0, rank = 1 },
        		{ name = "Holy Nova", id = 322112, passive = 0, rank = 2 },
        		{ name = "Holy Word: Chastise", id = 88625, passive = 0, rank = 1 },
        		{ name = "Holy Word: Sanctify", id = 34861, passive = 0, rank = 1 },
        		{ name = "Holy Word: Serenity", id = 2050, passive = 0, rank = 1 },
        		{ name = "Holy Words", id = 63733, passive = 0, rank = 2 },
        		{ name = "Mass Resurrection", id = 212036, passive = 0, rank = 1 },
        		{ name = "Mastery: Echo of Light", id = 77485, passive = 0, rank = 1 },
        		{ name = "Prayer of Healing", id = 596, passive = 0, rank = 1 },
        		{ name = "Prayer of Mending", id = 33076, passive = 0, rank = 1 },
        		{ name = "Prayer of Mending", id = 319912, passive = 0, rank = 2 },
        		{ name = "Purify", id = 527, passive = 0, rank = 1 },
        		{ name = "Renew", id = 139, passive = 0, rank = 1 },
        		{ name = "Shadow Word: Pain", id = 589, passive = 0, rank = 1 },
        		{ name = "Smite", id = 262861, passive = 0, rank = 2 },
        		{ name = "Spirit of Redemption", id = 20711, passive = 0, rank = 1 },
        		{ name = "Symbol of Hope", id = 64901, passive = 0, rank = 1 },
        	},
        	SHADOW = {
        		{ name = "Atonement", id = 81749, passive = 0, rank = 1 },
        		{ name = "Focused Will", id = 285485, passive = 0, rank = 2 },        		
        		{ name = "Holy Nova", id = 132157, passive = 0, rank = 1 },
                { name = "Holy Nova", id = 322112, passive = 0, rank = 2 },
        		{ name = "Mass Resurrection", id = 212036, passive = 0, rank = 1 },
        		{ name = "Mastery: Grace", id = 271534, passive = 0, rank = 1 },
        		{ name = "Mind Blast", id = 231682, passive = 0, rank = 2 },
        		{ name = "Mind Sear", id = 48045, passive = 0, rank = 1 },
        		{ name = "Pain Suppression", id = 33206, passive = 0, rank = 1 },
        		{ name = "Penance", id = 47540, passive = 0, rank = 1 },
        		{ name = "Power Word: Barrier", id = 62618, passive = 0, rank = 1 },
        		{ name = "Power Word: Fortitude", id = 21562, passive = 0, rank = 1 },        		
        		{ name = "Power Word: Radiance", id = 194509, passive = 0, rank = 1 },
                { name = "Power Word: Radiance", id = 322115, passive = 0, rank = 2 },
        		{ name = "Power of the Dark Side", id = 198068, passive = 0, rank = 1 },
        		{ name = "Purify", id = 527, passive = 0, rank = 1 },
        		{ name = "Rapture", id = 47536, passive = 0, rank = 1 },
        		{ name = "Shadow Mend", id = 186263, passive = 0, rank = 1 },
        		{ name = "Shadowfiend", id = 34433, passive = 0, rank = 1 },
        		{ name = "Shadowfiend", id = 343726, passive = 0, rank = 2 },
        		{ name = "Smite", id = 585, passive = 0, rank = 1 },
        		{ name = "Smite", id = 262861, passive = 0, rank = 2 },
        	},
        	COVENANT = {
        		{ name = "Boon of the Ascended", id = 325013, passive = 0, rank = 1 },
        		{ name = "Unholy Nova", id = 324724, passive = 0, rank = 1 },
        		{ name = "Fae Guardians", id = 327661, passive = 0, rank = 1 },
                { name = "Mindgames", id = 323673, passive = 0, rank = 1 }
        	},
        },
        ROGUE = {
        	BASIC = {
        		{ name = "Blind", id = 2094, passive = 0, rank = 1 },
        		{ name = "Cheap Shot", id = 1833, passive = 0, rank = 1 },
        		{ name = "Cloak of Shadows", id = 31224, passive = 0, rank = 1 },
        		{ name = "Crimson Vial", id = 185311, passive = 0, rank = 1 },
        		{ name = "Detection", id = 56814, passive = 0, rank = 1 },
        		{ name = "Distract", id = 1725, passive = 0, rank = 1 },
        		{ name = "Evasion", id = 5277, passive = 0, rank = 1 },
        		{ name = "Eviscerate", id = 196819, passive = 0, rank = 1 },
        		{ name = "Feint", id = 1966, passive = 0, rank = 1 },
        		{ name = "Fleet Footed", id = 31209, passive = 1, rank = 1 },
        		{ name = "Kick", id = 1766, passive = 0, rank = 1 },
        		{ name = "Kidney Shot", id = 408, passive = 0, rank = 1 },
        		{ name = "Pick Lock", id = 1804, passive = 0, rank = 1 },
        		{ name = "Pick Pocket", id = 921, passive = 0, rank = 1 },
        		{ name = "Sap", id = 6770, passive = 0, rank = 1 },
        		{ name = "Shiv", id = 5938, passive = 0, rank = 1 },
        		{ name = "Shroud of Concealment", id = 114018, passive = 0, rank = 1 },
        		{ name = "Slice and Dice", id = 315496, passive = 0, rank = 1 },
        		{ name = "Sprint", id = 2983, passive = 0, rank = 1 },
        		{ name = "Stealth", id = 1784, passive = 0, rank = 1 },
        		{ name = "Tricks of the Trade", id = 57934, passive = 0, rank = 1 },
        		{ name = "Vanish", id = 1856, passive = 0, rank = 1 },
        	},
        	ASSASSINATION = {
        		{ name = "Ambush", id = 8676, passive = 0, rank = 1 },
        		{ name = "Deadly Poison", id = 2823, passive = 0, rank = 1 },
        		{ name = "Envenom", id = 32645, passive = 0, rank = 1 },
        		{ name = "Fan of Knives", id = 51723, passive = 0, rank = 1 },
        		{ name = "Garrote", id = 703, passive = 0, rank = 1 },
        		{ name = "Garrote", id = 231719, passive = 0, rank = 2 },
        		{ name = "Improved Poisons", id = 14117, passive = 0, rank = 1 },
        		{ name = "Improved Poisons", id = 330542, passive = 0, rank = 2 },        		
        		{ name = "Mastery: Potent Assassin", id = 76803, passive = 0, rank = 1 },
                { name = "Mastery: Potent Assassin", id = 319473, passive = 0, rank = 2 },
        		{ name = "Mutilate", id = 1329, passive = 0, rank = 1 },
        		{ name = "Poisoned Knife", id = 185565, passive = 0, rank = 1 },
        		{ name = "Rupture", id = 1943, passive = 0, rank = 1 },
        		{ name = "Seal Fate", id = 14190, passive = 0, rank = 1 },
        		{ name = "Shadowstep", id = 36554, passive = 0, rank = 1 },
        		{ name = "Shiv", id = 319032, passive = 0, rank = 2 },
        		{ name = "Sinister Strike", id = 279877, passive = 0, rank = 2 },
        		{ name = "Slice and Dice", id = 344362, passive = 0, rank = 2 },
        		{ name = "Vendetta", id = 79140, passive = 0, rank = 1 },
        		{ name = "Venomous Wounds", id = 79134, passive = 0, rank = 1 },
        		{ name = "Wound Poison", id = 319066, passive = 0, rank = 2 },
        	},
        	OUTLAW = {
        		{ name = "Adrenaline Rush", id = 13750, passive = 0, rank = 1 },
        		{ name = "Ambush", id = 8676, passive = 0, rank = 1 },        		
        		{ name = "Between the Eyes", id = 315341, passive = 0, rank = 1 },
                { name = "Between the Eyes", id = 235484, passive = 0, rank = 2 },
        		{ name = "Blade Flurry", id = 13877, passive = 0, rank = 1 },
        		{ name = "Blade Flurry", id = 331851, passive = 0, rank = 2 },        		
        		{ name = "Combat Potency", id = 61329, passive = 0, rank = 1 },
                { name = "Combat Potency", id = 35551, passive = 0, rank = 2 },
        		{ name = "Dispatch", id = 2098, passive = 0, rank = 1 },
        		{ name = "Evasion", id = 344363, passive = 0, rank = 2 },
        		{ name = "Gouge", id = 1776, passive = 0, rank = 1 },
        		{ name = "Grappling Hook", id = 195457, passive = 0, rank = 1 },
        		{ name = "Grappling Hook", id = 319600, passive = 0, rank = 2 },
        		{ name = "Mastery: Main Gauche", id = 76806, passive = 0, rank = 1 },
        		{ name = "Pistol Shot", id = 185763, passive = 0, rank = 1 },
        		{ name = "Restless Blades", id = 79096, passive = 0, rank = 1 },
        		{ name = "Roll the Bones", id = 315508, passive = 0, rank = 1 },
        		{ name = "Ruthlessness", id = 14161, passive = 0, rank = 1 },        		
        		{ name = "Sinister Strike", id = 193315, passive = 0, rank = 1 },
                { name = "Sinister Strike", id = 279876, passive = 0, rank = 2 },
        	},
        	SUBTLETY = {        		
        		{ name = "Backstab", id = 53, passive = 0, rank = 1 },
                { name = "Backstab", id = 319949, passive = 0, rank = 2 },
        		{ name = "Black Powder", id = 319175, passive = 0, rank = 1 },
        		{ name = "Black Powder", id = 319178, passive = 0, rank = 2 },
        		{ name = "Deepening Shadows", id = 185314, passive = 0, rank = 1 },        		
        		{ name = "Eviscerate", id = 196819, passive = 0, rank = 1 },
                { name = "Eviscerate", id = 231716, passive = 0, rank = 2 },
        		{ name = "Find Weakness", id = 316219, passive = 0, rank = 1 },
        		{ name = "Mastery: Executioner", id = 76808, passive = 0, rank = 1 },
        		{ name = "Relentless Strikes", id = 58423, passive = 1, rank = 1 },
        		{ name = "Rupture", id = 1943, passive = 0, rank = 1 },
        		{ name = "Shadow Blades", id = 121471, passive = 0, rank = 1 },
        		{ name = "Shadow Dance", id = 185313, passive = 0, rank = 1 },
        		{ name = "Shadow Techniques", id = 196912, passive = 0, rank = 1 },
        		{ name = "Shadowstep", id = 36554, passive = 0, rank = 1 },
        		{ name = "Shadowstrike", id = 185438, passive = 0, rank = 1 },
        		{ name = "Shuriken Storm", id = 197835, passive = 0, rank = 1 },
        		{ name = "Shuriken Storm", id = 319951, passive = 0, rank = 2 },
        		{ name = "Shuriken Toss", id = 114014, passive = 0, rank = 1 },
        		{ name = "Sprint", id = 245751, passive = 0, rank = 2 },
        		{ name = "Symbols of Death", id = 212283, passive = 0, rank = 1 },
        		{ name = "Symbols of Death", id = 328077, passive = 0, rank = 2 },
        	},
        	COVENANT = {
        		{ name = "Echoing Reprimand", id = 323547, passive = 0, rank = 1 },
        		{ name = "Serrated Bone Spike", id = 328547, passive = 0, rank = 1 },                
        		{ name = "Sepsis", id = 328305, passive = 0, rank = 1 },
                { name = "Flagellation", id = 323654, passive = 0, rank = 1 }
        	},
        },
        SHAMAN = {
        	BASIC = {
        		{ name = "Ancestral Spirit", id = 2008, passive = 0, rank = 1 },
        		{ name = "Astral Recall", id = 556, passive = 0, rank = 1 },
        		{ name = "Astral Shift", id = 108271, passive = 0, rank = 1 },
        		{ name = "Astral Shift", id = 343196, passive = 0, rank = 2 },
        		{ name = "Bloodlust", id = 2825, passive = 0, rank = 1 },
        		{ name = "Capacitor Totem", id = 192058, passive = 0, rank = 1 },
        		{ name = "Chain Heal", id = 1064, passive = 0, rank = 1 },
        		{ name = "Chain Lightning", id = 188443, passive = 0, rank = 1 },
        		{ name = "Earth Elemental", id = 198103, passive = 0, rank = 1 },
        		{ name = "Earthbind Totem", id = 2484, passive = 0, rank = 1 },
        		{ name = "Far Sight", id = 6196, passive = 0, rank = 1 },
        		{ name = "Flame Shock", id = 188389, passive = 0, rank = 1 },
        		{ name = "Flametongue Weapon", id = 318038, passive = 0, rank = 1 },
        		{ name = "Frost Shock", id = 196840, passive = 0, rank = 1 },
        		{ name = "Ghost Wolf", id = 2645, passive = 0, rank = 1 },
        		{ name = "Healing Stream Totem", id = 5394, passive = 0, rank = 1 },
        		{ name = "Healing Surge", id = 8004, passive = 0, rank = 1 },
        		{ name = "Hex", id = 51514, passive = 0, rank = 1 },
        		{ name = "Hex", id = 343198, passive = 0, rank = 2 },
        		{ name = "Improved Reincarnation", id = 319352, passive = 0, rank = 1 },
        		{ name = "Lightning Bolt", id = 188196, passive = 0, rank = 1 },
        		{ name = "Lightning Shield", id = 192106, passive = 0, rank = 1 },
        		{ name = "Primal Strike", id = 73899, passive = 0, rank = 1 },
        		{ name = "Purge", id = 370, passive = 0, rank = 1 },
        		{ name = "Reincarnation", id = 20608, passive = 1, rank = 1 },
        		{ name = "Tremor Totem", id = 8143, passive = 0, rank = 1 },
        		{ name = "Water Walking", id = 546, passive = 0, rank = 1 },
        		{ name = "Wind Shear", id = 57994, passive = 0, rank = 1 },
        	},
        	ELEMENTAL = {
        		{ name = "Chain Lightning", id = 231722, passive = 0, rank = 2 },
        		{ name = "Cleanse Spirit", id = 51886, passive = 0, rank = 1 },
        		{ name = "Earth Shock", id = 8042, passive = 0, rank = 1 },
        		{ name = "Earthquake", id = 61882, passive = 0, rank = 1 },        		
        		{ name = "Elemental Fury", id = 60188, passive = 0, rank = 1 },
                { name = "Elemental Fury", id = 343190, passive = 0, rank = 2 },
        		{ name = "Fire Elemental", id = 198067, passive = 0, rank = 1 },
        		{ name = "Fire Elemental Totem", id = 343226, passive = 0, rank = 2 },        		
        		{ name = "Lava Burst", id = 51505, passive = 0, rank = 1 },
                { name = "Lava Burst", id = 231721, passive = 0, rank = 2 },
        		{ name = "Lava Surge", id = 77756, passive = 0, rank = 1 },
        		{ name = "Mastery: Elemental Overload", id = 168534, passive = 0, rank = 1 },
        		{ name = "Primal Strike", id = 73899, passive = 0, rank = 1 },
        		{ name = "Spiritwalker's Grace", id = 79206, passive = 0, rank = 1 },
        		{ name = "Thunderstorm", id = 51490, passive = 0, rank = 1 },
        	},
        	ENHANCEMENT = {
        		{ name = "Chain Lightning", id = 334308, passive = 0, rank = 2 },
        		{ name = "Cleanse Spirit", id = 51886, passive = 0, rank = 1 },
        		{ name = "Crash Lightning", id = 187874, passive = 0, rank = 1 },
        		{ name = "Feral Spirit", id = 51533, passive = 0, rank = 1 },        		
        		{ name = "Lava Lash", id = 60103, passive = 0, rank = 1 },
                { name = "Lava Lash", id = 334033, passive = 0, rank = 2 },
        		{ name = "Maelstrom Weapon", id = 187880, passive = 0, rank = 1 },
        		{ name = "Mastery: Enhanced Elements", id = 77223, passive = 0, rank = 1 },
        		{ name = "Spirit Walk", id = 58875, passive = 0, rank = 1 },
        		{ name = "Stormbringer", id = 201845, passive = 0, rank = 1 },
        		{ name = "Stormbringer", id = 319930, passive = 0, rank = 2 },
        		{ name = "Stormstrike", id = 17364, passive = 0, rank = 1 },        		
        		{ name = "Windfury Totem", id = 8512, passive = 0, rank = 1 },
                { name = "Windfury Totem", id = 343211, passive = 0, rank = 2 },
        		{ name = "Windfury Weapon", id = 33757, passive = 0, rank = 1 },
        	},
        	RESTORATION = {
        		{ name = "Ancestral Vision", id = 212048, passive = 0, rank = 1 },
        		{ name = "Chain Heal", id = 231780, passive = 0, rank = 2 },
        		{ name = "Earth Shield", id = 974, passive = 0, rank = 1 },
        		{ name = "Healing Rain", id = 73920, passive = 0, rank = 1 },
        		{ name = "Healing Tide Totem", id = 108280, passive = 0, rank = 1 },
        		{ name = "Healing Tide Totem", id = 343205, passive = 0, rank = 2 },
        		{ name = "Healing Wave", id = 77472, passive = 0, rank = 1 },        		
        		{ name = "Lava Burst", id = 51505, passive = 0, rank = 1 },
                { name = "Lava Burst", id = 231721, passive = 0, rank = 2 },
        		{ name = "Lava Surge", id = 77756, passive = 0, rank = 1 },        		
        		{ name = "Mana Tide Totem", id = 16191, passive = 0, rank = 1 },
                { name = "Mana Tide Totem", id = 343182, passive = 0, rank = 2 },
        		{ name = "Mastery: Deep Healing", id = 77226, passive = 0, rank = 1 },
        		{ name = "Purify Spirit", id = 77130, passive = 0, rank = 1 },
        		{ name = "Resurgence", id = 16196, passive = 0, rank = 1 },
        		{ name = "Riptide", id = 61295, passive = 0, rank = 1 },
        		{ name = "Spirit Link Totem", id = 98008, passive = 0, rank = 1 },
        		{ name = "Spiritwalker's Grace", id = 79206, passive = 0, rank = 1 },        		
        		{ name = "Tidal Waves", id = 51564, passive = 0, rank = 1 },
                { name = "Tidal Waves", id = 231785, passive = 0, rank = 2 },
        		{ name = "Water Shield", id = 52127, passive = 0, rank = 1 },
        	},
        	COVENANT = {
        		{ name = "Vesper Totem", id = 324386, passive = 0, rank = 1 },
        		{ name = "Primordial Wave", id = 326059, passive = 0, rank = 1 },
                { name = "Fae Transfusion", id = 328923, passive = 0, rank = 1 },        		
                { name = "Chain Harvest", id = 320674, passive = 0, rank = 1 }
        	},
        },
        WARLOCK = {
        	BASIC = {
        		{ name = "Banish", id = 710, passive = 0, rank = 1 },
        		{ name = "Command Demon", id = 119898, passive = 0, rank = 1 },
        		{ name = "Corruption", id = 172, passive = 0, rank = 1 },
        		{ name = "Create Healthstone", id = 6201, passive = 0, rank = 1 },
        		{ name = "Create Soulwell", id = 29893, passive = 0, rank = 1 },
        		{ name = "Curse of Exhaustion", id = 334275, passive = 0, rank = 1 },
        		{ name = "Curse of Tongues", id = 1714, passive = 0, rank = 1 },
        		{ name = "Curse of Weakness", id = 702, passive = 0, rank = 1 },
        		{ name = "Demonic Circle", id = 48018, passive = 0, rank = 1 },
        		{ name = "Demonic Circle: Teleport", id = 48020, passive = 0, rank = 1 },
        		{ name = "Demonic Embrace", id = 288843, passive = 0, rank = 1 },
        		{ name = "Demonic Gateway", id = 111771, passive = 0, rank = 1 },
        		{ name = "Drain Life", id = 234153, passive = 0, rank = 1 },
        		{ name = "Eye of Kilrogg", id = 126, passive = 0, rank = 1 },        		
        		{ name = "Fear", id = 5782, passive = 0, rank = 1 },
                { name = "Fear", id = 342914, passive = 0, rank = 2 },
        		{ name = "Fel Domination", id = 333889, passive = 0, rank = 1 },
        		{ name = "Health Funnel", id = 755, passive = 0, rank = 1 },
        		{ name = "Ritual of Doom", id = 342601, passive = 0, rank = 1 },
        		{ name = "Ritual of Summoning", id = 698, passive = 0, rank = 1 },
        		{ name = "Shadow Bolt", id = 686, passive = 0, rank = 1 },
        		{ name = "Shadowfury", id = 30283, passive = 0, rank = 1 },
        		{ name = "Soul Leech", id = 108370, passive = 0, rank = 1 },
        		{ name = "Soul Shards", id = 246985, passive = 0, rank = 1 },
        		{ name = "Soulstone", id = 20707, passive = 0, rank = 1 },
        		{ name = "Subjugate Demon", id = 1098, passive = 0, rank = 1 },
        		{ name = "Unending Breath", id = 5697, passive = 0, rank = 1 },
        		{ name = "Unending Resolve", id = 104773, passive = 0, rank = 1 },
        	},
        	AFFLICTION = {
        		{ name = "Call Dreadstalkers", id = 104316, passive = 0, rank = 1 },
        		{ name = "Call Dreadstalkers", id = 334727, passive = 0, rank = 2 },
        		{ name = "Demonbolt", id = 264178, passive = 0, rank = 1 },
        		{ name = "Demonic Core", id = 267102, passive = 0, rank = 1 },
        		{ name = "Fel Firebolt", id = 334591, passive = 0, rank = 2 },
        		{ name = "Hand of Gul'dan", id = 105174, passive = 0, rank = 1 },
        		{ name = "Implosion", id = 196277, passive = 0, rank = 1 },
        		{ name = "Mastery: Master Demonologist", id = 77219, passive = 0, rank = 1 },
        		{ name = "Soul Link", id = 108415, passive = 0, rank = 1 },
        		{ name = "Soulstone", id = 231811, passive = 0, rank = 2 },
        		{ name = "Summon Demonic Tyrant", id = 265187, passive = 0, rank = 1 },
        		{ name = "Summon Demonic Tyrant", id = 334585, passive = 0, rank = 2 },
        	},
        	DEMONOLOGY = {
        		{ name = "Call Dreadstalkers", id = 104316, passive = 0, rank = 1 },
        		{ name = "Call Dreadstalkers", id = 334727, passive = 0, rank = 2 },
        		{ name = "Demonbolt", id = 264178, passive = 0, rank = 1 },
        		{ name = "Demonic Core", id = 267102, passive = 0, rank = 1 },
        		{ name = "Fel Firebolt", id = 334591, passive = 0, rank = 2 },
        		{ name = "Hand of Gul'dan", id = 105174, passive = 0, rank = 1 },
        		{ name = "Implosion", id = 196277, passive = 0, rank = 1 },
        		{ name = "Mastery: Master Demonologist", id = 77219, passive = 0, rank = 1 },
        		{ name = "Soul Link", id = 108415, passive = 0, rank = 1 },
        		{ name = "Soulstone", id = 231811, passive = 0, rank = 2 },        		
        		{ name = "Summon Demonic Tyrant", id = 265187, passive = 0, rank = 1 },
                { name = "Summon Demonic Tyrant", id = 334585, passive = 0, rank = 2 },
        	},
        	DESTRUCTION = {
        		{ name = "Backdraft", id = 196406, passive = 0, rank = 1 },
        		{ name = "Chaos Bolt", id = 116858, passive = 0, rank = 1 },
        		{ name = "Conflagrate", id = 17962, passive = 0, rank = 1 },
        		{ name = "Conflagrate", id = 231793, passive = 0, rank = 2 },        		
        		{ name = "Havoc", id = 80240, passive = 0, rank = 1 },
                { name = "Havoc", id = 335174, passive = 0, rank = 2 },
        		{ name = "Immolate", id = 348, passive = 0, rank = 1 },
        		{ name = "Incinerate", id = 29722, passive = 0, rank = 1 },
        		{ name = "Mastery: Chaotic Energies", id = 77220, passive = 0, rank = 1 },        		
        		{ name = "Rain of Fire", id = 5740, passive = 0, rank = 1 },
                { name = "Rain of Fire", id = 335189, passive = 0, rank = 2 },
        		{ name = "Soulstone", id = 231811, passive = 0, rank = 2 },        		
        		{ name = "Summon Infernal", id = 1122, passive = 0, rank = 1 },
                { name = "Summon Infernal", id = 335175, passive = 0, rank = 2 },
        	},
        	COVENANT = {
        		{ name = "Scouring Tithe", id = 312321, passive = 0, rank = 1 },
                { name = "Decimating Bolt", id = 325289, passive = 0, rank = 1 },
                { name = "Soul Rot", id = 325640, passive = 0, rank = 1 },
                { name = "Impending Catastrophe", id = 321792, passive = 0, rank = 1 }
        	},
        },
        WARRIOR = {
        	BASIC = {
        		{ name = "Battle Shout", id = 6673, passive = 0, rank = 1 },
        		{ name = "Berserker Rage", id = 18499, passive = 0, rank = 1 },
        		{ name = "Challenging Shout", id = 1161, passive = 0, rank = 1 },
        		{ name = "Charge", id = 100, passive = 0, rank = 1 },
        		{ name = "Hamstring", id = 1715, passive = 0, rank = 1 },
        		{ name = "Heroic Leap", id = 6544, passive = 0, rank = 1 },
        		{ name = "Heroic Throw", id = 57755, passive = 0, rank = 1 },
        		{ name = "Ignore Pain", id = 190456, passive = 0, rank = 1 },
        		{ name = "Intervene", id = 3411, passive = 0, rank = 1 },
        		{ name = "Intimidating Shout", id = 5246, passive = 0, rank = 1 },
        		{ name = "Pummel", id = 6552, passive = 0, rank = 1 },
        		{ name = "Rallying Cry", id = 97462, passive = 0, rank = 1 },
        		{ name = "Shattering Throw", id = 64382, passive = 0, rank = 1 },
        		{ name = "Shield Block", id = 2565, passive = 0, rank = 1 },
        		{ name = "Shield Slam", id = 23922, passive = 0, rank = 1 },
        		{ name = "Slam", id = 1464, passive = 0, rank = 1 },
        		{ name = "Spell Reflection", id = 23920, passive = 0, rank = 1 },
        		{ name = "Taunt", id = 355, passive = 0, rank = 1 },
        		{ name = "Victory Rush", id = 34428, passive = 0, rank = 1 },
        		{ name = "Whirlwind", id = 190411, passive = 0, rank = 1 },
        	},
        	ARMS = {
        		{ name = "Bladestorm", id = 227847, passive = 0, rank = 1 },        		
        		{ name = "Colossus Smash", id = 167105, passive = 0, rank = 1 },
                { name = "Colossus Smash", id = 316411, passive = 0, rank = 2 },        		
        		{ name = "Die by the Sword", id = 118038, passive = 0, rank = 1 },
                { name = "Die by the Sword", id = 315948, passive = 0, rank = 2 },
        		{ name = "Execute", id = 316405, passive = 0, rank = 2 },
        		{ name = "Execute", id = 231830, passive = 0, rank = 3 },
        		{ name = "Mastery: Deep Wounds", id = 262111, passive = 0, rank = 1 },        		
        		{ name = "Mortal Strike", id = 12294, passive = 0, rank = 1 },
                { name = "Mortal Strike", id = 261900, passive = 0, rank = 2 },        		
        		{ name = "Overpower", id = 7384, passive = 0, rank = 1 },
                { name = "Overpower", id = 316440, passive = 0, rank = 2 },
                { name = "Overpower", id = 316441, passive = 0, rank = 3 },        		
        		{ name = "Piercing Howl", id = 12323, passive = 0, rank = 1 },
        		{ name = "Seasoned Soldier", id = 279423, passive = 0, rank = 1 },
        		{ name = "Slam", id = 261901, passive = 0, rank = 2 },
                { name = "Slam", id = 316534, passive = 0, rank = 3 },        		
        		{ name = "Sweeping Strikes", id = 260708, passive = 0, rank = 1 },        		
        		{ name = "Sweeping Strikes", id = 316432, passive = 0, rank = 2 },
                { name = "Sweeping Strikes", id = 316433, passive = 0, rank = 3 },
        		{ name = "Tactician", id = 184783, passive = 0, rank = 1 },
        	},
        	FURY = {
        		{ name = "Bloodthirst", id = 23881, passive = 0, rank = 1 },
        		{ name = "Bloodthirst", id = 316537, passive = 0, rank = 2 },
        		{ name = "Die by the Sword", id = 118038, passive = 0, rank = 1 },
        		{ name = "Enrage", id = 184361, passive = 0, rank = 1 },
        		{ name = "Enrage", id = 316424, passive = 0, rank = 2 },
                { name = "Enrage", id = 316425, passive = 0, rank = 3 },        		
        		{ name = "Enraged Regeneration", id = 184364, passive = 0, rank = 1 },
        		{ name = "Enraged Regeneration", id = 316474, passive = 0, rank = 2 },
        		{ name = "Execute", id = 5308, passive = 0, rank = 1 },
        		{ name = "Execute", id = 316403, passive = 0, rank = 3 },
        		{ name = "Execute", id = 316402, passive = 0, rank = 2 },
        		{ name = "Execute", id = 231827, passive = 0, rank = 4 },
        		{ name = "Mastery: Unshackled Fury", id = 76856, passive = 0, rank = 1 },
        		{ name = "Piercing Howl", id = 12323, passive = 0, rank = 1 },
        		{ name = "Raging Blow", id = 85288, passive = 0, rank = 1 },
                { name = "Raging Blow", id = 316452, passive = 0, rank = 2 },
        		{ name = "Raging Blow", id = 316453, passive = 0, rank = 3 },        		        		
        		{ name = "Rampage", id = 184367, passive = 0, rank = 1 },
                { name = "Rampage", id = 316412, passive = 0, rank = 2 },
        		{ name = "Rampage", id = 316519, passive = 0, rank = 3 },
        		{ name = "Recklessness", id = 1719, passive = 0, rank = 1 },
        		{ name = "Recklessness", id = 316828, passive = 0, rank = 2 },
        		{ name = "Single-Minded Fury", id = 81099, passive = 0, rank = 1 },
        		{ name = "Titan's Grip", id = 46917, passive = 0, rank = 1 },
        		{ name = "Whirlwind", id = 12950, passive = 0, rank = 3 },
        		{ name = "Whirlwind", id = 190411, passive = 0, rank = 1 },
        		{ name = "Whirlwind", id = 316435, passive = 0, rank = 2 },
        	},
        	PROTECTION = {
        		{ name = "Avatar", id = 107574, passive = 0, rank = 1 },
        		{ name = "Avatar", id = 316438, passive = 0, rank = 2 },
        		{ name = "Deep Wounds", id = 115768, passive = 0, rank = 1 },        		
        		{ name = "Demoralizing Shout", id = 1160, passive = 0, rank = 1 },
                { name = "Demoralizing Shout", id = 316464, passive = 0, rank = 2 },
        		{ name = "Devastate", id = 20243, passive = 0, rank = 1 },
        		{ name = "Execute", id = 316405, passive = 0, rank = 2 },
        		{ name = "Execute", id = 231830, passive = 0, rank = 3 },
        		{ name = "Ignore Pain", id = 316778, passive = 0, rank = 2 },
        		{ name = "Last Stand", id = 12975, passive = 0, rank = 1 },
        		{ name = "Mastery: Critical Block", id = 76857, passive = 0, rank = 1 },
        		{ name = "Revenge", id = 6572, passive = 0, rank = 1 },
        		{ name = "Riposte", id = 161798, passive = 0, rank = 1 },
        		{ name = "Shield Slam", id = 231834, passive = 0, rank = 3 },
        		{ name = "Shield Slam", id = 316523, passive = 0, rank = 2 },
        		{ name = "Shield Slam", id = 316790, passive = 0, rank = 4 },
        		{ name = "Shield Wall", id = 871, passive = 0, rank = 1 },
        		{ name = "Shield Wall", id = 316834, passive = 0, rank = 2 },
        		{ name = "Shockwave", id = 46968, passive = 0, rank = 1 },
        		{ name = "Thunder Clap", id = 6343, passive = 0, rank = 1 },
        		{ name = "Thunder Clap", id = 316414, passive = 0, rank = 2 },
        		{ name = "Vanguard", id = 71, passive = 0, rank = 1 },
        		{ name = "Vanguard", id = 316428, passive = 0, rank = 2 },
        	},
        	COVENANT = {
        		{ name = "Spear of Bastion", id = 307865, passive = 0, rank = 1 },
                { name = "Conqueror's Banner", id = 324143, passive = 0, rank = 1 },
                { name = "Ancient Aftershock", id = 325886, passive = 0, rank = 1 },
                { name = "Condemn", id = 317349, passive = 0, rank = 1 },
        	},
        },
        COVENANT = {
        	GENERAL = {
        		{ name = "Summon Steward", id = 324739, passive = 0, rank = 1 },
        		{ name = "Fleshcraft", id = 324631, passive = 0, rank = 1 },
        		{ name = "Soulshape", id = 310143, passive = 0, rank = 1 },
                { name = "Door of Shadows", id = 340570, passive = 0, rank = 1 },
        	},
        } 
    }
    
    self.talents = {
        DEATHKNIGHT = {
        	BLOOD = {
        		{ name = "Heartbreaker", id = 221536},
        		{ name = "Blooddrinker", id = 206931},
        		{ name = "Tombstone", id = 219809},
        		{ name = "Rapid Decomposition", id = 194662},
        		{ name = "Hemostasis", id = 273946},
        		{ name = "Consumption", id = 274156},
        		{ name = "Foul Bulwark", id = 206974},
        		{ name = "Relish in Blood", id = 317610},
        		{ name = "Blood Tap", id = 221699},
        		{ name = "Will of the Necropolis", id = 206967},
        		{ name = "Anti-Magic Barrier", id = 205727},
        		{ name = "Mark of Blood", id = 206940},
        		{ name = "Grip of the Dead", id = 273952},
        		{ name = "Tightening Grasp", id = 206970},
        		{ name = "Wraith Walk", id = 212552},
        		{ name = "Voracious", id = 273953},
        		{ name = "Death Pact", id = 48743},
        		{ name = "Bloodworms", id = 195679},
        		{ name = "Purgatory", id = 114556},
        		{ name = "Red Thirst", id = 205723},
        		{ name = "Bonestorm", id = 194844},
        	},
        	FROST = {
        		{ name = "Inexorable Assault", id = 253593},
        		{ name = "Icy Talons", id = 194878},
        		{ name = "Cold Heart", id = 281208},
        		{ name = "Runic Attenuation", id = 207104},
        		{ name = "Murderous Efficiency", id = 207061},
        		{ name = "Horn of Winter", id = 57330},
        		{ name = "Death's Reach", id = 276079},
        		{ name = "Asphyxiate", id = 108194},
        		{ name = "Blinding Sleet", id = 207167},
        		{ name = "Avalanche", id = 207142},
        		{ name = "Frozen Pulse", id = 194909},
        		{ name = "Frostscythe", id = 207230},
        		{ name = "Permafrost", id = 207200},
        		{ name = "Wraith Walk", id = 212552},
        		{ name = "Death Pact", id = 48743},
        		{ name = "Gathering Storm", id = 194912},
        		{ name = "Hypothermic Presence", id = 321995},
        		{ name = "Glacial Advance", id = 194913},
        		{ name = "Icecap", id = 207126},
        		{ name = "Obliteration", id = 281238},
        		{ name = "Breath of Sindragosa", id = 152279},
        	},
        	UNHOLY = {
        		{ name = "Infected Claws", id = 207272},
        		{ name = "All Will Serve", id = 194916},
        		{ name = "Clawing Shadows", id = 207311},
        		{ name = "Bursting Sores", id = 207264},
        		{ name = "Ebon Fever", id = 207269},
        		{ name = "Unholy Blight", id = 115989},
        		{ name = "Grip of the Dead", id = 273952},
        		{ name = "Death's Reach", id = 276079},
        		{ name = "Asphyxiate", id = 108194},
        		{ name = "Pestilent Pustules", id = 194917},
        		{ name = "Harbinger of Doom", id = 276023},
        		{ name = "Soul Reaper", id = 343294},
        		{ name = "Spell Eater", id = 207321},
        		{ name = "Wraith Walk", id = 212552},
        		{ name = "Death Pact", id = 48743},
        		{ name = "Pestilence", id = 277234},
        		{ name = "Unholy Pact", id = 319230},
        		{ name = "Defile", id = 152280},
        		{ name = "Army of the Damned", id = 276837},
        		{ name = "Summon Gargoyle", id = 49206},
        		{ name = "Unholy Assault", id = 207289},
        	},
        },
        DEMONHUNTER = {
        	HAVOC = {
        		{ name = "Blind Fury", id = 203550},
        		{ name = "Demonic Appetite", id = 206478},
        		{ name = "Felblade", id = 232893},
        		{ name = "Insatiable Hunger", id = 258876},
        		{ name = "Burning Hatred", id = 320374},
        		{ name = "Demon Blades", id = 203555},
        		{ name = "Trail if Ruin", id = 258881},
        		{ name = "Unbound Chaos", id = 347461},
        		{ name = "Glaive Tempest", id = 342817},
        		{ name = "Sould Rendering", id = 204909},
        		{ name = "Desperate Instincts", id = 205411},
        		{ name = "Netherwalk", id = 196555},
        		{ name = "Cycle of Hatred", id = 258887},
        		{ name = "First Blood", id = 206416},
        		{ name = "Essence Break", id = 258860},
        		{ name = "Unleashed Power", id = 206477},
        		{ name = "Master of the Glaive", id = 203556},
        		{ name = "Fel Eruption", id = 211881},
        		{ name = "Demonic", id = 213410},
        		{ name = "Momentum", id = 206476},
        		{ name = "Fel Barrage", id = 258925},
        	},
        	VENGEANCE = {
        		{ name = "Abyssal Strike", id = 207550},
        		{ name = "Agonizing Flames", id = 207548},
        		{ name = "Felblade", id = 232893},
        		{ name = "Feast of Souls", id = 207697},
        		{ name = "Fallout", id = 227174},
        		{ name = "Burning Alive", id = 207739},
        		{ name = "Infernal Armor", id = 320331},
        		{ name = "Charred Flesh", id = 336639},
        		{ name = "Spirit Bomb", id = 247454},
        		{ name = "Soul Rending", id = 217996},
        		{ name = "Feed the Demon", id = 218612},
        		{ name = "Fracture", id = 263642},
        		{ name = "Concentrated Sigils", id = 207666},
        		{ name = "Quickened Sigils", id = 209281},
        		{ name = "Sigil of Chains", id = 202138},
        		{ name = "Void Reaver", id = 268175},
        		{ name = "Demonic", id = 321453},
        		{ name = "Soul Barrier", id = 263648},
        		{ name = "Last Resort", id = 209258},
        		{ name = "Ruinous Bulwark", id = 326853},
        		{ name = "Bulk Extraction", id = 320341},
        	},
        },
        DRUID = {
        	BALANCE = {
        		{ name = "Nature's Balance", id = 202430},
        		{ name = "Warrior of Elune", id = 202425},
        		{ name = "Force of Nature", id = 205636},
        		{ name = "Tiger Dash", id = 252216},
        		{ name = "Renewal", id = 108238},
        		{ name = "Wild Charge", id = 102401},
        		{ name = "Feral Affinity", id = 202157},
        		{ name = "Guardian Affinity", id = 197491},
        		{ name = "Restoration Affinity", id = 197492},
        		{ name = "Mighty Bash", id = 5211},
        		{ name = "Mass Entanglement", id = 102359},
        		{ name = "Heart of the Wild", id = 319454},
        		{ name = "Soul of the Forest", id = 114107},
        		{ name = "Starlord", id = 202345},
        		{ name = "Incarnation: Chosen of Elune", id = 102560},
        		{ name = "Stellar Drift", id = 202354},
        		{ name = "Twin Moons", id = 279620},
        		{ name = "Stellar Flare", id = 202347},
        		{ name = "New Moon", id = 274281},
        		{ name = "Solstice", id = 343647},
        		{ name = "Fury of Elune", id = 202770},
        	},
        	FERAL = {
        		{ name = "Predator", id = 202021},
        		{ name = "Sabertooth", id = 202031},
        		{ name = "Lunar Inspiration", id = 155580},
        		{ name = "Tiger Dash", id = 252216},
        		{ name = "Renewal", id = 108238},
        		{ name = "Wild Charge", id = 102401},
        		{ name = "Balance Affinity", id = 197488},
        		{ name = "Guardian Affinity", id = 217615},
        		{ name = "Restoration Affinity", id = 197492},
        		{ name = "Mighty Bash", id = 5211},
        		{ name = "Mass Entanglement", id = 102359},
        		{ name = "Heart of the Wild", id = 319454},
        		{ name = "Soul of the Forest", id = 158476},
        		{ name = "Savage Roar", id = 52610},
        		{ name = "Incarnation: King of the Jungle", id = 102543},
        		{ name = "Scent of Blood", id = 285564},
        		{ name = "Brutal Slash", id = 202028},
        		{ name = "Primal Wrath", id = 285381},
        		{ name = "Moment of Clarity", id = 236068},
        		{ name = "Bloodtalons", id = 319439},
        		{ name = "Feral Frenzy", id = 274837},
        	},
        	GUARDIAN = {
        		{ name = "Brambles", id = 203953},
        		{ name = "Blood Frenzy", id = 203962},
        		{ name = "Bristling Fur", id = 155835},
        		{ name = "Tiger Dash", id = 252216},
        		{ name = "Renewal", id = 108238},
        		{ name = "Wild Charge", id = 102401},
        		{ name = "Balance Affinity", id = 197488},
        		{ name = "Feral Affinity", id = 202155},
        		{ name = "Restoration Affinity", id = 197492},
        		{ name = "Mighty Bash", id = 5211},
        		{ name = "Mass Entanglement", id = 102359},
        		{ name = "Heart of the Wild", id = 319454},
        		{ name = "Soul of the Forest", id = 158477},
        		{ name = "Galactic Guardian", id = 203964},
        		{ name = "Incarnation: Guardian of Ursoc", id = 102558},
        		{ name = "Earthwarden", id = 203974},
        		{ name = "Survival of the Fittest", id = 203965},
        		{ name = "Guardian of Elune", id = 155578},
        		{ name = "Rend and Tear", id = 204053},
        		{ name = "Tooth and Claw", id = 135288},
        		{ name = "Pulverize", id = 80313},
        	},
        	RESTORATION = {
        		{ name = "Abundance", id = 207383},
        		{ name = "Nourish", id = 50464},
        		{ name = "Cenarion Ward", id = 102351},
        		{ name = "Tiger Dash", id = 252216},
        		{ name = "Renewal", id = 108238},
        		{ name = "Wild Charge", id = 102401},
        		{ name = "Balance Affinity", id = 197632},
        		{ name = "Feral Affinity", id = 197490},
        		{ name = "Guardian Affinity", id = 197491},
        		{ name = "Mighty Bash", id = 5211},
        		{ name = "Mass Entanglement", id = 102359},
        		{ name = "Heart of the Wild", id = 319454},
        		{ name = "Soul of the Forest", id = 158478},
        		{ name = "Cultivation", id = 200390},
        		{ name = "Incarnation: Tree of Life", id = 33891},
        		{ name = "Inner Peace", id = 197073},
        		{ name = "Spring Blossoms", id = 207385},
        		{ name = "Overgrowth", id = 203651},
        		{ name = "Photosynthesis", id = 274902},
        		{ name = "Germination", id = 155675},
        		{ name = "Flourish", id = 197721},
        	},
        },
        HUNTER = {
        	BEASTMASTERY = {
        		{ name = "Killer Instinct", id = 273887},
        		{ name = "Animal Companion", id = 267116},
        		{ name = "Dire Beast", id = 120679},
        		{ name = "Scent of Blood", id = 193532},
        		{ name = "One with the Pack", id = 199528},
        		{ name = "Chimaera Shot", id = 53209},
        		{ name = "Trailblazer", id = 199921},
        		{ name = "Natural Mending", id = 270581},
        		{ name = "Camouflage", id = 199483},
        		{ name = "Spitting Cobra", id = 257891},
        		{ name = "Thrill of the Hunt", id = 257944},
        		{ name = "A Murder of Crows", id = 131894},
        		{ name = "Born To Be Wild", id = 266921},
        		{ name = "Posthaste", id = 109215},
        		{ name = "Binding Shot", id = 109248},
        		{ name = "Stomp", id = 199530},
        		{ name = "Barrage", id = 120360},
        		{ name = "Stampede", id = 201430},
        		{ name = "Aspect of the Beast", id = 191384},
        		{ name = "Killer Cobra", id = 199532},
        		{ name = "Bloodshed", id = 321530},
        	},
        	MARKSMANSHIP = {
        		{ name = "Master Marksman", id = 260309},
        		{ name = "Serpent Sting", id = 271788},
        		{ name = "A Murder of Crows", id = 131894},
        		{ name = "Careful Aim", id = 260228},
        		{ name = "Barrage", id = 120360},
        		{ name = "Explosive Shot", id = 212431},
        		{ name = "Trailblazer", id = 199921},
        		{ name = "Natural Mending", id = 270581},
        		{ name = "Camouflage", id = 199483},
        		{ name = "Steady Focus", id = 193533},
        		{ name = "Streamline", id = 260367},
        		{ name = "Chimaera Shot", id = 342049},
        		{ name = "Born To Be Wild", id = 266921},
        		{ name = "Posthaste", id = 109215},
        		{ name = "Binding Shackles", id = 321468},
        		{ name = "Lethal Shots", id = 260393},
        		{ name = "Dead Eye", id = 321460},
        		{ name = "Double Tap", id = 260402},
        		{ name = "Calling the Shots", id = 260404},
        		{ name = "Lock and Load", id = 194595},
        		{ name = "Volley", id = 260243},
        	},
        	SURVIVAL = {
        		{ name = "Viper's Venom", id = 268501},
        		{ name = "Terms of Engagement", id = 265895},
        		{ name = "Alpha Predator", id = 269737},
        		{ name = "Guerrilla Tactics", id = 264332},
        		{ name = "Hydra's Bite", id = 260241},
        		{ name = "Butchery", id = 212436},
        		{ name = "Trailblazer", id = 199921},
        		{ name = "Natural Mending", id = 270581},
        		{ name = "Camouflage", id = 199483},
        		{ name = "Bloodseeker", id = 260248},
        		{ name = "Steel Trap", id = 162488},
        		{ name = "A Murder of Crows", id = 131894},
        		{ name = "Born To Be Wild", id = 266921},
        		{ name = "Posthaste", id = 109215},
        		{ name = "Binding Shot", id = 109248},
        		{ name = "Tip of the Spear", id = 260285},
        		{ name = "Mongoose Bite", id = 259387},
        		{ name = "Flanking Strike", id = 269751},
        		{ name = "Birds of Prey", id = 260331},
        		{ name = "Wildfire Infusion", id = 271014},
        		{ name = "Chakrams", id = 259391},
        	},
        },
        MAGE = {
        	ARCANE = {
        		{ name = "Amplification", id = 236628},
        		{ name = "Rule of Threes", id = 264354},
        		{ name = "Arcane Familiar", id = 205022},
        		{ name = "Master of Time", id = 342249},
        		{ name = "Shimmer", id = 212653},
        		{ name = "Slipstream", id = 236457},
        		{ name = "Incanter's Flow", id = 1463},
        		{ name = "Focus Magic", id = 321358},
        		{ name = "Rune of Power", id = 116011},
        		{ name = "Resonance", id = 205028},
        		{ name = "Arcane Echo", id = 342231},
        		{ name = "Nether Tempest", id = 114923},
        		{ name = "Chrono Shift", id = 235711},
        		{ name = "Ice Ward", id = 205036},
        		{ name = "Ring of Frost", id = 113724},
        		{ name = "Reverberate", id = 281482},
        		{ name = "Arcane Orb", id = 153626},
        		{ name = "Supernova", id = 157980},
        		{ name = "Overpowered", id = 155147},
        		{ name = "Time Anomaly", id = 210805},
        		{ name = "Enlightened", id = 321387},
        	},
        	FIRE = {
        		{ name = "Firestarter", id = 205026},
        		{ name = "Pyromaniac", id = 205020},
        		{ name = "Searing Touch", id = 269644},
        		{ name = "Blazing Soul", id = 235365},
        		{ name = "Shimmer", id = 212653},
        		{ name = "Blast Wave", id = 157981},
        		{ name = "Incanter's Flow", id = 1463},
        		{ name = "Focus Magic", id = 321358},
        		{ name = "Rune of Power", id = 116011},
        		{ name = "Flame On", id = 205029},
        		{ name = "Alexstrasza's Fury", id = 235870},
        		{ name = "From the Ashes", id = 342344},
        		{ name = "Frenetic Speed", id = 236058},
        		{ name = "Ice Ward", id = 205036},
        		{ name = "Ring of Frost", id = 113724},
        		{ name = "Flame Patch", id = 205037},
        		{ name = "Conflagration", id = 205023},
        		{ name = "Living Bomb", id = 44457},
        		{ name = "Kindling", id = 155148},
        		{ name = "Pyroclasm", id = 269650},
        		{ name = "Meteor", id = 153561},
        	},
        	FROST = {
        		{ name = "Bone Chilling", id = 205027},
        		{ name = "Lonely Winter", id = 205024},
        		{ name = "Ice Nova", id = 157997},
        		{ name = "Glacial Insulation", id = 235297},
        		{ name = "Shimmer", id = 212653},
        		{ name = "Ice Floes", id = 108839},
        		{ name = "Incanter's Flow", id = 1463},
        		{ name = "Focus Magic", id = 321358},
        		{ name = "Rune of Power", id = 116011},
        		{ name = "Frozen Touch", id = 205030},
        		{ name = "Chain Reaction", id = 278309},
        		{ name = "Ebonbolt", id = 257537},
        		{ name = "Frigid Winds", id = 235224},
        		{ name = "Ice Ward", id = 205036},
        		{ name = "Ring of Frost", id = 113724},
        		{ name = "Freezing Rain", id = 270233},
        		{ name = "Splitting Ice", id = 56377},
        		{ name = "Comet Storm", id = 153595},
        		{ name = "Thermal Void", id = 155149},
        		{ name = "Ray of Frost", id = 205021},
        		{ name = "Glacial Spike", id = 199786},
        	},
        },
        MONK = {
        	BREWMASTER = {
        		{ name = "Eye of the Tiger", id = 196607},
        		{ name = "Chi Wave", id = 115098},
        		{ name = "Chi Burst", id = 123986},
        		{ name = "Celerity", id = 115173},
        		{ name = "Chi Torpedo", id = 115008},
        		{ name = "Tiger's Lust", id = 116841},
        		{ name = "Light Brewing", id = 325093},
        		{ name = "Spitfire", id = 242580},
        		{ name = "Black Ox Brew", id = 115399},
        		{ name = "Tiger Tail Sweep", id = 264348},
        		{ name = "Summon Black Ox Statue", id = 115315},
        		{ name = "Ring of Peace", id = 116844},
        		{ name = "Bob and Weave", id = 280515},
        		{ name = "Healing Elixir", id = 122281},
        		{ name = "Dampen Harm", id = 122278},
        		{ name = "Special Delivery", id = 196730},
        		{ name = "Rushing Jade Wind", id = 116847},
        		{ name = "Exploding Keg", id = 325153},
        		{ name = "High Tolerance", id = 196737},
        		{ name = "Celestial Flames", id = 325177},
        		{ name = "Blackout Combo", id = 196736},
        	},
        	MISTWEAVER = {
        		{ name = "Mist Wrap", id = 197900},
        		{ name = "Chi Wave", id = 115098},
        		{ name = "Chi Burst", id = 123986},
        		{ name = "Celerity", id = 115173},
        		{ name = "Chi Torpedo", id = 115008},
        		{ name = "Tiger's Lust", id = 116841},
        		{ name = "Lifecycles", id = 197915},
        		{ name = "Spirit of the Crane", id = 210802},
        		{ name = "Mana Tea", id = 197908},
        		{ name = "Tiger Tail Sweep", id = 264348},
        		{ name = "Song of Chi-Ji", id = 198898},
        		{ name = "Ring of Peace", id = 116844},
        		{ name = "Healing Elixir", id = 122281},
        		{ name = "Diffuse Magic", id = 122783},
        		{ name = "Dampen Harm", id = 122278},
        		{ name = "Summon Jade Serpent Statue", id = 115313},
        		{ name = "Refreshing Jade Wind", id = 196725},
        		{ name = "Invoke Chi-Ji, the Red Crane", id = 325197},
        		{ name = "Focused Thunder", id = 197895},
        		{ name = "Upwelling", id = 274963},
        		{ name = "Rising Mist", id = 274909},
        	},
        	WINDWALKER = {
        		{ name = "Eye of the Tiger", id = 196607},
        		{ name = "Chi Wave", id = 115098},
        		{ name = "Chi Burst", id = 123986},
        		{ name = "Celerity", id = 115173},
        		{ name = "Chi Torpedo", id = 115008},
        		{ name = "Tiger's Lust", id = 116841},
        		{ name = "Ascension", id = 115396},
        		{ name = "Fist of the White Tiger", id = 261947},
        		{ name = "Energizing Elixir", id = 115288},
        		{ name = "Tiger Tail Sweep", id = 264348},
        		{ name = "Good Karma", id = 280195},
        		{ name = "Ring of Peace", id = 116844},
        		{ name = "Inner Strength", id = 261767},
        		{ name = "Diffuse Magic", id = 122783},
        		{ name = "Dampen Harm", id = 122278},
        		{ name = "Hit Combo", id = 196740},
        		{ name = "Rushing Jade Wind", id = 116847},
        		{ name = "Dance of Chi-Ji", id = 325201},
        		{ name = "Spiritual Focus", id = 280197},
        		{ name = "Whirling Dragon Punch", id = 152175},
        		{ name = "Serenity", id = 152173},
        	},
        },
        PALADIN = {
        	HOLY = {
        		{ name = "Crusader's Might", id = 196926},
        		{ name = "Bestow Faith", id = 223306},
        		{ name = "Light's Hammer", id = 114158},
        		{ name = "Saved by the Light", id = 157047},
        		{ name = "Judgment of Light", id = 183778},
        		{ name = "Holy Prism", id = 114165},
        		{ name = "Fist of Justice", id = 234299},
        		{ name = "Repentance", id = 20066},
        		{ name = "Blinding Light", id = 115750},
        		{ name = "Unbreakable Spirit", id = 114154},
        		{ name = "Cavalier", id = 230332},
        		{ name = "Rule of Law", id = 214202},
        		{ name = "Divine Purpose", id = 223817},
        		{ name = "Holy Avenger", id = 105809},
        		{ name = "Seraphim", id = 152262},
        		{ name = "Sanctified Wrath", id = 53376},
        		{ name = "Avenging Crusader", id = 216331},
        		{ name = "Awakening", id = 248033},
        		{ name = "Glimmer of Light", id = 325966},
        		{ name = "Beacon of Faith", id = 156910},
        		{ name = "Beacon of Virtue", id = 200025},
        	},
        	PROTECTION = {
        		{ name = "Holy Shield", id = 152261},
        		{ name = "Redoubt", id = 280373},
        		{ name = "Blessed Hammer", id = 204019},
        		{ name = "First Avenger", id = 203776},
        		{ name = "Crusader's Judgment", id = 204023},
        		{ name = "Moment of Glory", id = 327193},
        		{ name = "Fist of Justice", id = 234299},
        		{ name = "Repentance", id = 20066},
        		{ name = "Blinding Light", id = 115750},
        		{ name = "Unbreakable Spirit", id = 114154},
        		{ name = "Cavalier", id = 230332},
        		{ name = "Blessing of Spellwarding", id = 204018},
        		{ name = "Divine Purpose", id = 223817},
        		{ name = "Holy Avenger", id = 105809},
        		{ name = "Seraphim", id = 152262},
        		{ name = "Sanctified Wrath", id = 171648},
        		{ name = "Hand of the Protector", id = 315924},
        		{ name = "Consecrated Ground", id = 204054},
        		{ name = "Judgment of Light", id = 183778},
        		{ name = "Righteous Protector", id = 204074},
        		{ name = "Final Stand", id = 204077},
        	},
        	RETRIBUTION = {
        		{ name = "Zeal", id = 269569},
        		{ name = "Righteous Verdict", id = 267610},
        		{ name = "Execution Sentence", id = 343527},
        		{ name = "Fires of Justice", id = 203316},
        		{ name = "Blade of Wrath", id = 231832},
        		{ name = "Empyrean Power", id = 326732},
        		{ name = "Fist of Justice", id = 234299},
        		{ name = "Repentance", id = 20066},
        		{ name = "Blinding Light", id = 115750},
        		{ name = "Unbreakable Spirit", id = 114154},
        		{ name = "Cavalier", id = 230332},
        		{ name = "Eye for an Eye", id = 205191},
        		{ name = "Divine Purpose", id = 223817},
        		{ name = "Holy Avenger", id = 105809},
        		{ name = "Seraphim", id = 152262},
        		{ name = "Selfless Healer", id = 85804},
        		{ name = "Justicar's Vengeance", id = 215661},
        		{ name = "Healing Hands", id = 326734},
        		{ name = "Sanctified Wrath", id = 317866},
        		{ name = "Crusade", id = 231895},
        		{ name = "Final Reckoning", id = 343721},
        	},
        },
        PRIEST = {
        	DISCIPLINE = {
        		{ name = "Castigation", id = 193134},
        		{ name = "Twist of Fate", id = 265259},
        		{ name = "Schism", id = 214621},
        		{ name = "Body and Soul", id = 64129},
        		{ name = "Masochism", id = 193063},
        		{ name = "Angelic Feather", id = 121536},
        		{ name = "Shield Discipline", id = 197045},
        		{ name = "Mindbender", id = 123040},
        		{ name = "Power Word: Solace", id = 129250},
        		{ name = "Psychic Voice", id = 196704},
        		{ name = "Dominant Mind", id = 205367},
        		{ name = "Shining Force", id = 204263},
        		{ name = "Sins of the Many", id = 280391},
        		{ name = "Contrition", id = 197419},
        		{ name = "Shadow Covenant", id = 314867},
        		{ name = "Purge the Wicked", id = 204197},
        		{ name = "Divine Star", id = 110744},
        		{ name = "Halo", id = 120517},
        		{ name = "Lenience", id = 238063},
        		{ name = "Spirit Shell", id = 109964},
        		{ name = "Evangelism", id = 246287},
        	},
        	HOLY = {
        		{ name = "Enlightenment", id = 193155},
        		{ name = "Trail of Light", id = 200128},
        		{ name = "Renewed Faith", id = 341997},
        		{ name = "Angel's Mercy", id = 238100},
        		{ name = "Body and Soul", id = 64129},
        		{ name = "Angelic Feather", id = 121536},
        		{ name = "Cosmic Ripple", id = 238136},
        		{ name = "Guardian Angel", id = 200209},
        		{ name = "Afterlife", id = 196707},
        		{ name = "Psychic Voice", id = 196704},
        		{ name = "Censure", id = 200199},
        		{ name = "Shining Force", id = 204263},
        		{ name = "Surge of Light", id = 109186},
        		{ name = "Binding Heal", id = 32546},
        		{ name = "Prayer Circle", id = 321377},
        		{ name = "Benediction", id = 193157},
        		{ name = "Divine Star", id = 110744},
        		{ name = "Halo", id = 120517},
        		{ name = "Light of the Naaru", id = 196985},
        		{ name = "Apotheosis", id = 200183},
        		{ name = "Holy Word: Salvation", id = 265202},
        	},
        	SHADOW = {
        		{ name = "Fortress of the Mind", id = 193195},
        		{ name = "Death and Madness", id = 321291},
        		{ name = "Unfurling Darkness", id = 341273},
        		{ name = "Body and Soul", id = 64129},
        		{ name = "San'layn", id = 199855},
        		{ name = "Intangibility", id = 288733},
        		{ name = "Twist of Fate", id = 109142},
        		{ name = "Misery", id = 238558},
        		{ name = "Searing Nightmare", id = 341385},
        		{ name = "Last Word", id = 263716},
        		{ name = "Mind Bomb", id = 205369},
        		{ name = "Psychic Horror", id = 64044},
        		{ name = "Auspicious Spirits", id = 155271},
        		{ name = "Psychic Link", id = 199484},
        		{ name = "Shadow Crash", id = 205385},
        		{ name = "Damnation", id = 341374},
        		{ name = "Mindbender", id = 200174},
        		{ name = "Void Torrent", id = 263165},
        		{ name = "Ancient Madness", id = 341240},
        		{ name = "Hungering Void", id = 345218},
        		{ name = "Surrender to Madness", id = 319952},
        	},
        },
        ROGUE = {
        	ASSASSINATION = {
        		{ name = "Crimson Tempest", id = 121411},
        		{ name = "Exsanguinate", id = 200806},
        		{ name = "Hidden Blades", id = 270061},
        		{ name = "Poison Bomb", id = 255544},
        		{ name = "Venom Rush", id = 152152},
        		{ name = "Alacrity", id = 193539},
        		{ name = "Prey on the Weak", id = 131511},
        		{ name = "Iron Wire", id = 196861},
        		{ name = "Internal Bleeding", id = 154904},
        		{ name = "Leeching Poison", id = 280716},
        		{ name = "Cheat Death", id = 31230},
        		{ name = "Elusiveness", id = 79008},
        		{ name = "Marked for Death", id = 137619},
        		{ name = "Deeper Stratagem", id = 193531},
        		{ name = "Vigor", id = 14983},
        		{ name = "Nightstalker", id = 14062},
        		{ name = "Subterfuge", id = 108208},
        		{ name = "Master Assassin", id = 255989},
        		{ name = "Blindside", id = 328085},
        		{ name = "Elaborate Planning", id = 193640},
        		{ name = "Master Poisoner", id = 196864},
        	},
        	OUTLAW = {
        		{ name = "Weaponmaster", id = 200733},
        		{ name = "Quick Draw", id = 196938},
        		{ name = "Ghostly Strike", id = 196937},
        		{ name = "Acrobatic Strikes", id = 196924},
        		{ name = "Retractable Hook", id = 256188},
        		{ name = "Hit and Run", id = 196922},
        		{ name = "Vigor", id = 14983},
        		{ name = "Deeper Stratagem", id = 193531},
        		{ name = "Marked for Death", id = 137619},
        		{ name = "Iron Stomach", id = 193546},
        		{ name = "Cheat Death", id = 31230},
        		{ name = "Elusivness", id = 79008},
        		{ name = "Dirty Tricks", id = 108216},
        		{ name = "Blinding Powder", id = 256165},
        		{ name = "Prey on the Weak", id = 131511},
        		{ name = "Loaded Dice", id = 256170},
        		{ name = "Alacrity", id = 193539},
        		{ name = "Dreadblades", id = 343142},
        		{ name = "Dancing Steel", id = 272026},
        		{ name = "Blade Rush", id = 271877},
        		{ name = "Killing Spree", id = 51690},
        	},
        	SUBTLETY = {
        		{ name = "Weaponmaster", id = 193537},
        		{ name = "Premeditation", id = 343160},
        		{ name = "Gloomblade", id = 200758},
        		{ name = "Nightstalker", id = 14062},
        		{ name = "Subterfuge", id = 108208},
        		{ name = "Shadow Focus", id = 108209},
        		{ name = "Vigor", id = 14983},
        		{ name = "Deeper Stratagem", id = 193531},
        		{ name = "Marked for Death", id = 137619},
        		{ name = "Soothing Darkness", id = 200759},
        		{ name = "Cheat Death", id = 31230},
        		{ name = "Elusiveness", id = 79008},
        		{ name = "Shot in the Dark", id = 257505},
        		{ name = "Night Terrors", id = 277953},
        		{ name = "Prey on the Weak", id = 131511},
        		{ name = "Dark Shadow", id = 245687},
        		{ name = "Alacrity", id = 193539},
        		{ name = "Enveloping Shadows", id = 238104},
        		{ name = "Master of Shadows", id = 196976},
        		{ name = "Secret Technique", id = 280719},
        		{ name = "Shuriken Tornado", id = 277925},
        	},
        },
        SHAMAN = {
        	ELEMENTAL = {
        		{ name = "Earthen Rage", id = 170374},
        		{ name = "Echo of the Elements", id = 333919},
        		{ name = "Static Discharge", id = 342243},
        		{ name = "Aftershock", id = 273221},
        		{ name = "Echoing Shock", id = 320125},
        		{ name = "Elemental Blast", id = 117014},
        		{ name = "Spirit Wolf", id = 260878},
        		{ name = "Earth Shield", id = 974},
        		{ name = "Static Charge", id = 265046},
        		{ name = "Master of the Elements", id = 16166},
        		{ name = "Storm Elemental", id = 192249},
        		{ name = "Liquid Magma Totem", id = 192222},
        		{ name = "Nature's Guardian", id = 30884},
        		{ name = "Ancestral Guidance", id = 108281},
        		{ name = "Wind Rush Totem", id = 192077},
        		{ name = "Surge of Power", id = 262303},
        		{ name = "Primal Elementalist", id = 117013},
        		{ name = "Icefury", id = 210714},
        		{ name = "Unlimited Power", id = 260895},
        		{ name = "Stormkeeper", id = 191634},
        		{ name = "Ascendance", id = 114050},
        	},
        	ENHANCEMENT = {
        		{ name = "Lashing Flames", id = 334046},
        		{ name = "Forceful Winds", id = 262647},
        		{ name = "Elemental Blast", id = 117014},
        		{ name = "Stormflurry", id = 344357},
        		{ name = "Hot Hand", id = 201900},
        		{ name = "Ice Strike", id = 342240},
        		{ name = "Spirit Wolf", id = 260878},
        		{ name = "Earth Shield", id = 974},
        		{ name = "Static Charge", id = 265046},
        		{ name = "Elemental Assault", id = 210853},
        		{ name = "Hailstorm", id = 334195},
        		{ name = "Fire Nova", id = 333974},
        		{ name = "Nature's Guardian", id = 30884},
        		{ name = "Feral Lunge", id = 196884},
        		{ name = "Wind Rush Totem", id = 192077},
        		{ name = "Crashing Storm", id = 192246},
        		{ name = "Stormkeeper", id = 320137},
        		{ name = "Sundering", id = 197214},
        		{ name = "Elemental Spirits", id = 262624},
        		{ name = "Earthen Spike", id = 188089},
        		{ name = "Ascendance", id = 114051},
        	},
        	RESTORATION = {
        		{ name = "Torrent", id = 200072},
        		{ name = "Undulation", id = 200071},
        		{ name = "Unleash Life", id = 73685},
        		{ name = "Echo of the Elements", id = 108283},
        		{ name = "Deluge", id = 200076},
        		{ name = "Surge of Earth", id = 320746},
        		{ name = "Spirit Wolf", id = 260878},
        		{ name = "Earthgrab Totem", id = 51485},
        		{ name = "Static Charge", id = 265046},
        		{ name = "Ancestral Vigor", id = 207401},
        		{ name = "Earthen Wall Totem", id = 198838},
        		{ name = "Ancestral Protection Totem", id = 207399},
        		{ name = "Nature's Guardian", id = 30884},
        		{ name = "Graceful Spirit", id = 192088},
        		{ name = "Wind Rush Totem", id = 192077},
        		{ name = "Flash Flood", id = 280614},
        		{ name = "Downpour", id = 207778},
        		{ name = "Cloudburst Totem", id = 157153},
        		{ name = "High Tide", id = 157154},
        		{ name = "Wellspring", id = 197995},
        		{ name = "Ascendance", id = 114052},
        	},
        },
        WARLOCK = {
        	AFFLICTION = {
        		{ name = "Nightfall", id = 108558},
        		{ name = "Inevitable Demise", id = 334319},
        		{ name = "Drain Soul", id = 198590},
        		{ name = "Writhe in Agony", id = 196102},
        		{ name = "Absolute Corruption", id = 196103},
        		{ name = "Siphon Life", id = 63106},
        		{ name = "Demon Skin", id = 219272},
        		{ name = "Burning Rush", id = 111400},
        		{ name = "Dark Pact", id = 108416},
        		{ name = "Sow the Seeds", id = 196226},
        		{ name = "Phantom Singularity", id = 205179},
        		{ name = "Vile Taint", id = 278350},
        		{ name = "Darkfury", id = 264874},
        		{ name = "Mortal Coil", id = 6789},
        		{ name = "Howl of Terror", id = 5484},
        		{ name = "Dark Caller", id = 334183},
        		{ name = "Haunt", id = 48181},
        		{ name = "Grimoire of Sacrifice", id = 108503},
        		{ name = "Soul Conduit", id = 215941},
        		{ name = "Creeping Death", id = 264000},
        		{ name = "Dark Soul: Misery", id = 113860},
        	},
        	DEMONOLOGY = {
        		{ name = "Dreadlash", id = 264078},
        		{ name = "Bilescourge Bombers", id = 267211},
        		{ name = "Demonic Strength", id = 267171},
        		{ name = "Demonic Calling", id = 205145},
        		{ name = "Power Siphon", id = 264130},
        		{ name = "Doom", id = 603},
        		{ name = "Demon Skin", id = 219272},
        		{ name = "Burning Rush", id = 111400},
        		{ name = "Dark Pact", id = 108416},
        		{ name = "From the Shadows", id = 267170},
        		{ name = "Soul Strike", id = 264057},
        		{ name = "Summon Vilefiend", id = 264119},
        		{ name = "Darkfury", id = 264874},
        		{ name = "Mortal Coil", id = 6789},
        		{ name = "Howl of Terror", id = 5484},
        		{ name = "Soul Conduit", id = 215941},
        		{ name = "Inner Demons", id = 267216},
        		{ name = "Grimoire: Felguard", id = 111898},
        		{ name = "Sacrificed Souls", id = 267214},
        		{ name = "Demonic Consumption", id = 267215},
        		{ name = "Nether Portal", id = 267217},
        	},
        	DESTRUCTION = {
        		{ name = "Flashover", id = 267115},
        		{ name = "Eradication", id = 196412},
        		{ name = "Soul Fire", id = 6353},
        		{ name = "Reverse Entropy", id = 205148},
        		{ name = "Internal Combustion", id = 266134},
        		{ name = "Shadowburn", id = 17877},
        		{ name = "Demon Skin", id = 219272},
        		{ name = "Burning Rush", id = 111400},
        		{ name = "Dark Pact", id = 108416},
        		{ name = "Inferno", id = 270545},
        		{ name = "Fire and Brimstone", id = 196408},
        		{ name = "Cataclysm", id = 152108},
        		{ name = "Darkfury", id = 264874},
        		{ name = "Mortal Coil", id = 6789},
        		{ name = "Howl of Terror", id = 5484},
        		{ name = "Roaring Blaze", id = 205184},
        		{ name = "Rain of Chaos", id = 266086},
        		{ name = "Grimoire of Sacrifice", id = 108503},
        		{ name = "Soul Conduit", id = 215941},
        		{ name = "Channel Demonfire", id = 196447},
        		{ name = "Dark Soul: Instability", id = 113858},
        	},
        },
        WARRIOR = {
        	ARMS = {
        		{ name = "War Machine", id = 262231},
        		{ name = "Sudden Death", id = 29725},
        		{ name = "Skullsplitter", id = 260643},
        		{ name = "Double Time", id = 103827},
        		{ name = "Impending Victory", id = 202168},
        		{ name = "Storm Bolt", id = 107570},
        		{ name = "Massacre", id = 281001},
        		{ name = "Fervor of Battle", id = 202316},
        		{ name = "Rend", id = 772},
        		{ name = "Second Wind", id = 29838},
        		{ name = "Bounding Stride", id = 202163},
        		{ name = "Defensive Stance", id = 197690},
        		{ name = "Collateral Damage", id = 334779},
        		{ name = "Warbreaker", id = 262161},
        		{ name = "Cleave", id = 845},
        		{ name = "In For The Kill", id = 248621},
        		{ name = "Avatar", id = 107574},
        		{ name = "Deadly Calm", id = 262228},
        		{ name = "Anger Management", id = 152278},
        		{ name = "Dreadnaught", id = 262150},
        		{ name = "Ravager", id = 152277},
        	},
        	FURY = {
        		{ name = "War Machine", id = 346002},
        		{ name = "Sudden Death", id = 280721},
        		{ name = "Fresh Meat", id = 215568},
        		{ name = "Double Time", id = 103827},
        		{ name = "Impending Victory", id = 202168},
        		{ name = "Massacre", id = 206315},
        		{ name = "Frenzy", id = 335077},
        		{ name = "Onslaught", id = 315720},
        		{ name = "Furious Charge", id = 202224},
        		{ name = "Bounding String", id = 202163},
        		{ name = "Warpaint", id = 208154},
        		{ name = "Seethe", id = 335091},
        		{ name = "Frothing Berserker", id = 215571},
        		{ name = "Cruelty", id = 335070},
        		{ name = "Meat Cleaver", id = 280392},
        		{ name = "Dragon Roar", id = 118000},
        		{ name = "Bladestorm", id = 46924},
        		{ name = "Anger Management", id = 152278},
        		{ name = "Reckless Abandon", id = 202751},
        		{ name = "Siegebreaker", id = 280772},
        	},
        	PROTECTION = {
        		{ name = "War Machine", id = 316733},
        		{ name = "Punish", id = 275334},
        		{ name = "Devastator", id = 236279},
        		{ name = "Double Time", id = 103827},
        		{ name = "Rumbling Earth", id = 275339},
        		{ name = "Storm Bold", id = 107570},
        		{ name = "Best Served Cold", id = 202560},
        		{ name = "Booming Voice", id = 202743},
        		{ name = "DragonRoar", id = 118000},
        		{ name = "Crackling Thunder", id = 203201},
        		{ name = "Bounding Strike", id = 202163},
        		{ name = "Menace", id = 275338},
        		{ name = "Never Surrender", id = 202561},
        		{ name = "Indomitable", id = 202095},
        		{ name = "Impending Victory", id = 202168},
        		{ name = "Into the Fray", id = 202603},
        		{ name = "Unstoppable Force", id = 275336},
        		{ name = "Ravager", id = 228920},
        		{ name = "Anger Management", id = 152278},
        		{ name = "Heavy Repercussions", id = 203177},
        		{ name = "Bolster", id = 280001},
        	},
        }
    }
    
    self.pvp_talents = {
        DEATHKNIGHT = {
        	BLOOD = {
        		{ name = "Blood for Blood", id = 233411},
        		{ name = "Dark Simulacrum", id = 77606},
        		{ name = "Death Chain", id = 203173},
        		{ name = "Decomposing Aura", id = 199720},
        		{ name = "Dome of Ancient Shadow", id = 328718},
        		{ name = "Last Dance", id = 233412},
        		{ name = "Murderous Intent", id = 207018},
        		{ name = "Necrotic Aura", id = 199642},
        		{ name = "Rot and Wither", id = 202727},
        		{ name = "Strangulate", id = 47476},
        		{ name = "Walking Dead", id = 202731},
        	},
        	FROST = {
        		{ name = "Cadaverous Pallor", id = 201995},
        		{ name = "Chill Streak", id = 305392},
        		{ name = "Dark Simulacrum", id = 77606},
        		{ name = "Dead of Winter", id = 287250},
        		{ name = "Deathchill", id = 204080},
        		{ name = "Delirium", id = 233396},
        		{ name = "Dome of Ancient Shadow", id = 328718},
        		{ name = "Heartstop Aura", id = 199719},
        		{ name = "Necrotic Aura", id = 199642},
        		{ name = "Transfusion", id = 288977},
        	},
        	UNHOLY = {
        		{ name = "Cadaverous Pallor", id = 201995},
        		{ name = "Dark Simulacrum", id = 77606},
        		{ name = "Decomposing Aura", id = 199720},
        		{ name = "Dome of Ancient Shadow", id = 328718},
        		{ name = "Life and Death", id = 288855},
        		{ name = "Necromancer's Bargain", id = 288848},
        		{ name = "Necrotic Aura", id = 199642},
        		{ name = "Necrotic Strike", id = 223829},
        		{ name = "Raise Abomination", id = 288853},
        		{ name = "Reanimation", id = 210128},
        		{ name = "Transfusion", id = 288977},
        	},
        },
        DEMONHUNTER = {
        	HAVOC = {
        		{ name = "Cleansed by Flame", id = 205625},
        		{ name = "Cover of Darkness", id = 227635},
        		{ name = "Demonic Origins", id = 235893},
        		{ name = "Detainment", id = 205596},
        		{ name = "Eye of Leotheras", id = 206649},
        		{ name = "Mana Break", id = 203704},
        		{ name = "Mana Rift", id = 235903},
        		{ name = "Mortal Rush", id = 328725},
        		{ name = "Rain from Above", id = 206803},
        		{ name = "Reverse Magic", id = 205604},
        		{ name = "Unending Hatred", id = 213480},
        	},
        	VENGEANCE = {
        		{ name = "Cleansed by Flame", id = 205625},
        		{ name = "Demonic Trample", id = 205629},
        		{ name = "Detainment", id = 205596},
        		{ name = "Everlasting Hunt", id = 205626},
        		{ name = "Illidan's Grasp", id = 205630},
        		{ name = "Jagged Spikes", id = 205627},
        		{ name = "Reverse Magic", id = 205604},
        		{ name = "Sigil Mastery", id = 211489},
        		{ name = "Tormentor", id = 207029},
        		{ name = "Unending Hatred", id = 213480},
        	},
        },
        DRUID = {
        	BALANCE = {
        		{ name = "Celestial Guardian", id = 233754},
        		{ name = "Crescent Burn", id = 200567},
        		{ name = "Deep Roots", id = 233755},
        		{ name = "Dying Stars", id = 232546},
        		{ name = "Faerie Swarm", id = 209749},
        		{ name = "High Winds", id = 200931},
        		{ name = "Moon and Stars", id = 233750},
        		{ name = "Moonkin Aura", id = 209740},
        		{ name = "Prickling Thorns", id = 200549},
        		{ name = "Protector of the Grove", id = 209730},
        		{ name = "Thorns", id = 305497},
        	},
        	FERAL = {
        		{ name = "Ferocious Wound", id = 236020},
        		{ name = "Freedom of the Herd", id = 213200},
        		{ name = "Fresh Wound", id = 203224},
        		{ name = "High Winds", id = 200931},
        		{ name = "King of the Jungle", id = 203052},
        		{ name = "Leader of the Pack", id = 202626},
        		{ name = "Malorne's Swiftness", id = 236012},
        		{ name = "Rip and Tear", id = 203242},
        		{ name = "Savage Momentum", id = 205673},
        		{ name = "Strength of the Wild", id = 236019},
        		{ name = "Thorns", id = 305497},
        	},
        	GUARDIAN = {
        		{ name = "Alpha Challenge", id = 207017},
        		{ name = "Charging Bash", id = 228431},
        		{ name = "Demoralizing Roar", id = 201664},
        		{ name = "Den Mother", id = 236180},
        		{ name = "Entangling Claws", id = 202226},
        		{ name = "Freedom of the Herd", id = 213200},
        		{ name = "High Winds", id = 200931},
        		{ name = "Malorne's Swiftness", id = 236147},
        		{ name = "Master Shapeshifter", id = 236144},
        		{ name = "Overrun", id = 202246},
        		{ name = "Raging Frenzy", id = 236153},
        		{ name = "Roar of the Protector", id = 329042},
        		{ name = "Sharpened Claws", id = 202110},
        		{ name = "Toughness", id = 201259},
        	},
        	RESTORATION = {
        		{ name = "Deep Roots", id = 233755},
        		{ name = "Disentanglement", id = 233673},
        		{ name = "Early Spring", id = 203624},
        		{ name = "Entangling Bark", id = 247543},
        		{ name = "Focused Growth", id = 203553},
        		{ name = "High Winds", id = 200931},
        		{ name = "Mark of the Wild", id = 289318},
        		{ name = "Master Shapeshifter", id = 289237},
        		{ name = "Reactive Resin", id = 203399},
        		{ name = "Thorns", id = 305497},
        	},
        },
        HUNTER = {
        	BEASTMASTERY = {
        		{ name = "Dire Beast: Basilisk", id = 205691},
        		{ name = "Dire Beast: Hawk", id = 208652},
        		{ name = "Dragonscale Armor", id = 202589},
        		{ name = "Hi-Explosive Trap", id = 236776},
        		{ name = "Hunting Pack", id = 203235},
        		{ name = "Interlope", id = 248518},
        		{ name = "Roar of Sacrifice", id = 53480},
        		{ name = "Scorpid Sting", id = 202900},
        		{ name = "Spider Sting", id = 202914},
        		{ name = "Survival Tactics", id = 202746},
        		{ name = "The Beast Within", id = 212668},
        		{ name = "Viper Sting", id = 202797},
        		{ name = "Wild Protector", id = 204190},
        	},
        	MARKSMANSHIP = {
        		{ name = "Dragonscale Armor", id = 202589},
        		{ name = "Hi-Explosive Trap", id = 236776},
        		{ name = "Hunting Pack", id = 203235},
        		{ name = "Ranger's Finesse", id = 248443},
        		{ name = "Roar of Sacrifice", id = 53480},
        		{ name = "Scatter Shot", id = 213691},
        		{ name = "Scorpid Sting", id = 202900},
        		{ name = "Sniper Shot", id = 203155},
        		{ name = "Spider Sting", id = 202914},
        		{ name = "Survival Tactics", id = 202746},
        		{ name = "Trueshot Mastery", id = 203129},
        		{ name = "Viper Sting", id = 202797},
        	},
        	SURVIVAL = {
        		{ name = "Diamond Ice", id = 203340},
        		{ name = "Dragonscale Armor", id = 202589},
        		{ name = "Hi-Explosive Trap", id = 236776},
        		{ name = "Hunting Pack", id = 203235},
        		{ name = "Mending Bandage", id = 212640},
        		{ name = "Roar of Sacrifice", id = 53480},
        		{ name = "Scorpid Sting", id = 202900},
        		{ name = "Spider Sting", id = 202914},
        		{ name = "Sticky Tar", id = 203264},
        		{ name = "Survival Tactics", id = 202746},
        		{ name = "Tracker's Net", id = 212638},
        		{ name = "Viper Sting", id = 202797},
        	},
        },
        MAGE = {
        	ARCANE = {
        		{ name = "Arcane Empowerment", id = 276741},
        		{ name = "Dampened Magic", id = 236788},
        		{ name = "Kleptomania", id = 198100},
        		{ name = "Mass Invisibility", id = 198158},
        		{ name = "Master of Escape", id = 210476},
        		{ name = "Netherwind Armor", id = 198062},
        		{ name = "Prismatic Cloak", id = 198064},
        		{ name = "Temporal Shield", id = 198111},
        		{ name = "Torment the Weak", id = 198151},
        	},
        	FIRE = {
        		{ name = "Controlled Burn", id = 280450},
        		{ name = "Dampened Magic", id = 236788},
        		{ name = "Flamecannon", id = 203284},
        		{ name = "Greater Pyroblast", id = 203286},
        		{ name = "Kleptomania", id = 198100},
        		{ name = "Netherwind Armor", id = 198062},
        		{ name = "Prismatic Cloak", id = 198064},
        		{ name = "Pyrokinesis", id = 203283},
        		{ name = "Tinder", id = 203275},
        		{ name = "World in Flames", id = 203280},
        	},
        	FROST = {
        		{ name = "Controlled Burn", id = 280450},
        		{ name = "Dampened Magic", id = 236788},
        		{ name = "Flamecannon", id = 203284},
        		{ name = "Greater Pyroblast", id = 203286},
        		{ name = "Kleptomania", id = 198100},
        		{ name = "Netherwind Armor", id = 198062},
        		{ name = "Prismatic Cloak", id = 198064},
        		{ name = "Pyrokinesis", id = 203283},
        		{ name = "Tinder", id = 203275},
        		{ name = "World in Flames", id = 203280},
        	},
        },
        MONK = {
        	BREWMASTER = {
        		{ name = "Admonishment", id = 207025},
        		{ name = "Avert Harm", id = 202162},
        		{ name = "Craft: Nimble Brew", id = 213658},
        		{ name = "Double Barrel", id = 202335},
        		{ name = "Eerie Fermentation", id = 205147},
        		{ name = "Guided Meditation", id = 202200},
        		{ name = "Hot Trub", id = 202126},
        		{ name = "Incendiary Breath", id = 202272},
        		{ name = "Microbrew", id = 202107},
        		{ name = "Mighty Ox Kick", id = 202370},
        		{ name = "Niuzao's Essence", id = 232876},
        	},
        	MISTWEAVER = {
        		{ name = "Chrysalis", id = 202424},
        		{ name = "Counteract Magic", id = 202428},
        		{ name = "Dome of Mist", id = 202577},
        		{ name = "Eminence", id = 216255},
        		{ name = "Grapple Weapon", id = 233759},
        		{ name = "Healing Sphere", id = 205234},
        		{ name = "Refreshing Breeze", id = 202523},
        		{ name = "Surging Mist", id = 227344},
        		{ name = "Zen Focus Tea", id = 209584},
        	},
        	WINDWALKER = {
        		{ name = "Alpha Tiger", id = 287503},
        		{ name = "Disabling Reach", id = 201769},
        		{ name = "Grapple Weapon", id = 233759},
        		{ name = "Pressure Points", id = 345829},
        		{ name = "Reverse Harm", id = 342928},
        		{ name = "Ride the Wind", id = 201372},
        		{ name = "Tigereye Brew", id = 247483},
        		{ name = "Turbo Fists", id = 287681},
        		{ name = "Wind Waker", id = 287506},
        	},
        },
        PALADIN = {
        	HOLY = {
        		{ name = "Avenging Light", id = 199441},
        		{ name = "Blessed Hands", id = 199454},
        		{ name = "Cleanse the Weak", id = 199330},
        		{ name = "Darkest before the Dawn", id = 210378},
        		{ name = "Divine Favor", id = 210294},
        		{ name = "Divine Vision", id = 199324},
        		{ name = "Hallowed Ground", id = 216868},
        		{ name = "Light's Grace", id = 216327},
        		{ name = "Spear Hand Strike", id = 116705},
        		{ name = "Spreading the Word", id = 199456},
        		{ name = "Ultimate Sacrifice", id = 199452},
        	},
        	PROTECTION = {
        		{ name = "Cleansing Light", id = 236186},
        		{ name = "Guarded by the Light", id = 216855},
        		{ name = "Guardian of the Forgotten Queen", id = 228049},
        		{ name = "Hallowed Ground", id = 216868},
        		{ name = "Inquisition", id = 207028},
        		{ name = "Judgments of the Pure", id = 216860},
        		{ name = "Luminescence", id = 199428},
        		{ name = "Sacred Duty", id = 216853},
        		{ name = "Shield of Virtue", id = 215652},
        		{ name = "Steed of Glory", id = 199542},
        		{ name = "Unbound Freedom", id = 305394},
        		{ name = "Warrior of Light", id = 210341},
        	},
        	RETRIBUTION = {
        		{ name = "Aura of Reckoning", id = 247675},
        		{ name = "Blessing of Sanctuary", id = 210256},
        		{ name = "Cleansing Light", id = 236186},
        		{ name = "Divine Punisher", id = 204914},
        		{ name = "Jurisdiction", id = 204979},
        		{ name = "Law and Order", id = 204934},
        		{ name = "Lawbringer", id = 246806},
        		{ name = "Luminescence", id = 199428},
        		{ name = "Ultimate Retribution", id = 287947},
        		{ name = "Unbound Freedom", id = 305394},
        		{ name = "Vengeance Aura", id = 210323},
        	},
        },
        PRIEST = {
        	DISCIPLINE = {
        		{ name = "Archangel", id = 197862},
        		{ name = "Dark Archangel", id = 197871},
        		{ name = "Dome of Light", id = 197590},
        		{ name = "Purification", id = 196162},
        		{ name = "Purified Resolve", id = 196439},
        		{ name = "Searing Light", id = 215768},
        		{ name = "Strength of Soul", id = 197535},
        		{ name = "Thoughtsteal", id = 316262},
        		{ name = "Trinity", id = 214205},
        		{ name = "Ultimate Radiance", id = 236499},
        	},
        	HOLY = {
        		{ name = "Cardinal Mending", id = 328529},
        		{ name = "Delivered from Evil", id = 196611},
        		{ name = "Divine Ascension", id = 328530},
        		{ name = "Greater Fade", id = 213602},
        		{ name = "Greater Heal", id = 289666},
        		{ name = "Holy Ward", id = 213610},
        		{ name = "Holy Word: Concentration", id = 289657},
        		{ name = "Miracle Worker", id = 235587},
        		{ name = "Ray of Hope", id = 197268},
        		{ name = "Spirit of the Redeemer", id = 215982},
        		{ name = "Thoughtsteal", id = 316262},
        	},
        	SHADOW = {
        		{ name = "Driven to Madness", id = 199259},
        		{ name = "Greater Fade", id = 213602},
        		{ name = "Lasting Plague", id = 341167},
        		{ name = "Mind Trauma", id = 199445},
        		{ name = "Psyfiend", id = 211522},
        		{ name = "Thoughtsteal", id = 316262},
        		{ name = "Void Origins", id = 228630},
        		{ name = "Void Shield", id = 280749},
        		{ name = "Void Shift", id = 108968},
        	},
        },
        ROGUE = {
        	ASSASSINATION = {
        		{ name = "Creeping Venom", id = 198092},
        		{ name = "Death from Above", id = 269513},
        		{ name = "Flying Daggers", id = 198128},
        		{ name = "Honor Among Thieves", id = 198032},
        		{ name = "Intent to Kill", id = 197007},
        		{ name = "Maneuverability", id = 197000},
        		{ name = "Mind-Numbing Poison", id = 197050},
        		{ name = "Neurotoxin", id = 206328},
        		{ name = "Smoke Bomb", id = 212182},
        		{ name = "System Shock", id = 198145},
        	},
        	OUTLAW = {
        		{ name = "Boarding Party", id = 209752},
        		{ name = "Cheap Tricks", id = 212035},
        		{ name = "Control is King", id = 212217},
        		{ name = "Death From Above", id = 269513},
        		{ name = "Dismantle", id = 207777},
        		{ name = "Drink Up Me Hearties", id = 212210},
        		{ name = "Honor Among Thieves", id = 198032},
        		{ name = "Maneuverability", id = 197000},
        		{ name = "Plunder Armor", id = 198529},
        		{ name = "Smonke Bomb", id = 212182},
        		{ name = "Take Your Cut", id = 198265},
        		{ name = "Thick as Thieves", id = 221622},
        		{ name = "Turn the Tables", id = 198020},
        	},
        	SUBTLETY = {
        		{ name = "Cold Blood", id = 213981},
        		{ name = "Dagger in the Dark", id = 198675},
        		{ name = "Death from Above", id = 269513},
        		{ name = "Honor Among Thieves", id = 198032},
        		{ name = "Maneuverability", id = 197000},
        		{ name = "Shadowy Duel", id = 207736},
        		{ name = "Silhouette", id = 197899},
        		{ name = "Smoke Bomb", id = 212182},
        		{ name = "Thief's Bargain", id = 212081},
        		{ name = "Veil of Midnight", id = 198952},
        	},
        },
        SHAMAN = {
        	ELEMENTAL = {
        		{ name = "Control of Lava", id = 204393},
        		{ name = "Counterstrike Totem", id = 204331},
        		{ name = "Elemental Attunement", id = 204385},
        		{ name = "Grounding Totem", id = 204336},
        		{ name = "Lightning Lasso", id = 305483},
        		{ name = "Purifying Waters", id = 204247},
        		{ name = "Skyfury Totem", id = 204330},
        		{ name = "Spectral Recovery", id = 204261},
        		{ name = "Swelling Waves", id = 204264},
        		{ name = "Traveling Storms", id = 204403},
        	},
        	ENHANCEMENT = {
        		{ name = "Counterstrike Totem", id = 204331},
        		{ name = "Ethereal Form", id = 210918},
        		{ name = "Grounding Totem", id = 204336},
        		{ name = "Purifying Waters", id = 204247},
        		{ name = "Ride the Lightning", id = 289874},
        		{ name = "Shamanism", id = 193876},
        		{ name = "Skyfury Totem", id = 204330},
        		{ name = "Spectral Recovery", id = 204261},
        		{ name = "Swelling Waves", id = 204264},
        		{ name = "Thundercharge", id = 204366},
        	},
        	RESTORATION = {
        		{ name = "Ancestral Gift", id = 290254},
        		{ name = "Cleansing Waters", id = 290250},
        		{ name = "Counterstrike Totem", id = 204331},
        		{ name = "Electrocute", id = 206642},
        		{ name = "Grounding Totem", id = 204336},
        		{ name = "Skyfury Totem", id = 204330},
        		{ name = "Spectral Recovery", id = 204261},
        		{ name = "Spirit Link", id = 204293},
        		{ name = "Swelling Waves", id = 204264},
        		{ name = "Tidebringer", id = 236501},
        		{ name = "Voodoo Mastery", id = 204268},
        	},
        },
        WARLOCK = {
        	AFFLICTION = {
        		{ name = "Amplify Curse", id = 328774},
        		{ name = "Bane of Fragility", id = 199954},
        		{ name = "Bane of Shadows", id = 234877},
        		{ name = "Casting Circle", id = 221703},
        		{ name = "Deathbolt", id = 264106},
        		{ name = "Demon Armor", id = 285933},
        		{ name = "Essence Drain", id = 221711},
        		{ name = "Gateway Mastery", id = 248855},
        		{ name = "Nether Ward", id = 212295},
        		{ name = "Rampant Afflictions", id = 335052},
        		{ name = "Rapid Contagion", id = 344566},
        		{ name = "Rot and Decay", id = 212371},
        		{ name = "Soulshatter", id = 212356},
        	},
        	DEMONOLOGY = {
        		{ name = "Amplify Curse", id = 328774},
        		{ name = "Bane of Fragility", id = 199954},
        		{ name = "Call Fel Lord", id = 212459},
        		{ name = "Call Felhunter", id = 212619},
        		{ name = "Call Observer", id = 201996},
        		{ name = "Casting Circle", id = 221703},
        		{ name = "Essence Drain", id = 221711},
        		{ name = "Gateway Mastery", id = 248855},
        		{ name = "Master Summoner", id = 212628},
        		{ name = "Nether Ward", id = 212295},
        		{ name = "Pleasure through Pain", id = 212618},
        		{ name = "Singe Magic", id = 212623},
        	},
        	DESTRUCTION = {
        		{ name = "Amplify Curse", id = 328774},
        		{ name = "Bane of Fragility", id = 199954},
        		{ name = "Bane of Havoc", id = 200546},
        		{ name = "Casting Circle", id = 221703},
        		{ name = "Cremation", id = 212282},
        		{ name = "Demon Armor", id = 285933},
        		{ name = "Essence Drain", id = 221711},
        		{ name = "Fel Fissure", id = 200586},
        		{ name = "Focused Chaos", id = 233577},
        		{ name = "Gateway Mastery", id = 248855},
        		{ name = "Nether Ward", id = 212295},
        	},
        },
        WARRIOR = {
        	ARMS = {
        		{ name = "Death Sentence", id = 198500},
        		{ name = "Demolition", id = 329033},
        		{ name = "Disarm", id = 236077},
        		{ name = "Duel", id = 236273},
        		{ name = "Master and Commander", id = 235941},
        		{ name = "Overwatch", id = 329035},
        		{ name = "Shadow of the Colossus", id = 198807},
        		{ name = "Sharpen Blade", id = 198817},
        		{ name = "Storm of Destruction", id = 236308},
        		{ name = "War Banner", id = 236320},
        	},
        	FURY = {
        		{ name = "Barbarian", id = 280745},
        		{ name = "Battle Trance", id = 213857},
        		{ name = "Bloodrage", id = 329038},
        		{ name = "Death Senctence", id = 198500},
        		{ name = "Death Wish", id = 199261},
        		{ name = "Demolition", id = 329033},
        		{ name = "Disarm", id = 236077},
        		{ name = "Enduring Rage", id = 198877},
        		{ name = "Master and Commander", id = 235941},
        		{ name = "Overwatch", id = 329035},
        		{ name = "Slaughterhouse", id = 280747},
        	},
        	PROTECTION = {
        		{ name = "Bodyguard", id = 213871},
        		{ name = "Demolition", id = 329033},
        		{ name = "Disarm", id = 236077},
        		{ name = "Dragon Charge", id = 206572},
        		{ name = "Morale Killer", id = 199023},
        		{ name = "Oppressor", id = 205800},
        		{ name = "Overwatch", id = 329035},
        		{ name = "Rebound", id = 213915},
        		{ name = "Shield Bash", id = 198912},
        		{ name = "Sword and Board", id = 199127},
        		{ name = "Thunderstruck", id = 199045},
        		{ name = "Warpath", id = 199086},
        	},
        }
    }    
    return self
end

-- returns a table with all spells for a certain class and spec
-- @param _class the identifier for the class
-- @param _sepc the identifier for the specilization
-- @param _includeBasic boolean indicates if the basic class spells will be returned aswell
-- @param _includeCovenant boolean indicates if the covenant class spells will be returned aswell
function SpellLib:GetClassSpecSpells(_class, _spec, _includeBasic, _includeCovenant)
    _spec = _spec or "ALL"
    _includeBasic = _includeBasic or true
    _includeCovenant = _includeCovenant or true
    
    local getSpells = {}                                                                               
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) set to an illegal value.')
        return nil
    elseif _class == "ALL" then
        return self.classSpells[_class][_spec]
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetClassSpecSpells() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() second parameter (_spec) set to an illegal value.')
        return nil
    else        
        if _spec == "ALL" then
            return self.classSpells[_class]
        else
            getSpells[_spec] = self.classSpells[_class][_spec]
            if _includeBasic == true then
                getSpells['BASIC'] = {}
                for i,v in pairs(self.classSpells[_class]['BASIC']) do
                    tinsert(getSpells['BASIC'], v)
                end                 
            end            
            if _includeCovenant == true then 
                getSpells['COVENANT'] = {}
                for i,v in pairs(self.classSpells[_class]['COVENANT']) do
                    tinsert(getSpells['COVENANT'], v)
                end                            
            end
        end     
    end
    return getSpells                    
end

-- returns a table with all general COVENANT abilities
function SpellLib:GetGeneralCovenantSpells()
    local getSpells = self.classSpells['COVENANT']['GENERAL']
    return getSpells
end

-- returns a table with all COVENANT abilites for a certain class
-- @param _class Class identifier
function SpellLib:GetClassCovenantSpells(_class)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetClassCovenantSpells() first parameter (_class) set to an illegal value.')
        return nil
    end
    
    return self.classSpells[_class]['COVENANT']
end

-- returns a table with all talents for a certain class spec
function SpellLib:GetSpecTalents(_class, _spec)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() first parameter (_class) set to an illegal value.')
        return nil
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecTalents() second parameter (_spec) set to an illegal value.')
        return nil
    end
    
    return self.talents[_class][_spec]
end

-- returns a table with all pvp talents for a certain class spec
function SpellLib:GetSpecPVPTalents(_class, _spec)
    if _class == nil or _class == "" then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() first parameter (_class) is undefined.')
        return nil
    elseif self:tContains(self.classNames, _class) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() first parameter (_class) set to an illegal value.')
        return nil
    elseif _spec == nil or _spec == "" then 
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() second parameter (_spec) is undefined.')
        return nil         
    elseif self:tContains(self.specNames, _spec) ~= 1 then
        print(self.errorText .. 'Error in SpellLib:GetSpecPVPTalents() second parameter (_spec) set to an illegal value.')
        return nil
    end
    
    return self.pvp_talents[_class][_spec]
end

-- checks if a table contains a certain item
-- @param _table the table to search
-- @param _item the item  value
function SpellLib:tContains(_table, _item)
    local index = 1;
    while _table[index] do
        if ( _item == _table[index] ) then        
            return 1;
        end
        index = index + 1;
    end
    return nil;
end